<?php
/*
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );



class Sql2excelControllerSqlexcelimportxml extends Sql2excelController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'import'  , 'importXML' );
	}

	/**
	 * Import uploaded XML file
	 * @return void
	 */
	function importXML()
	{
		$msg =  '';		
		$section = (int) Jrequest::getVar('section', 0, 'POST', 'int');
		$category = (int) Jrequest::getVar('category', 0, 'POST', 'int');

		if ( $section > 0 && $category > 0 ) {
			if ( isset($_FILES['uploadedfile']) ) {
				$cnt = 0;
				$origName = $_FILES['uploadedfile']['name'];
				$tmpFN = $_FILES['uploadedfile']['tmp_name'];
			
				$extension = strtolower(substr($origName, strlen($origName)-4));

				if ( $extension == '.xml' ) {

					if ( file_exists($tmpFN) ) {
						$xmlData = $this->xml2array($tmpFN);
						if ( is_array($xmlData) && isset($xmlData['workbooks']) ) {
							$workBooks = $xmlData['workbooks'];
							if ( isset($workBooks['component']) && isset($workBooks['version']) ) {
								$nrElements = count($workBooks);
								for ($i=0;$i<$nrElements;$i++ ) {
									$element = array_shift($workBooks);

									if ( is_array($element) && isset($element['title']) && isset($element['link_title']) ) {
										if ( $this->importWB($element,$section,$category) ) {
											$cnt++;
										}
									}
									
								}
								$msg =  $cnt . ' ' . JText::_('Workbook(s) Imported!');
							}
						}


					}
				}
			}
		} else {
			$msg = JText::_('ERROR : Please specify a Section and Category');
		}
		
		if ( $msg == '' ) {
			JError::raiseError(500, JText::_('No Workbooks Imported! Please check file format!' ) );
		} else {
			$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
			$this->setRedirect($link, $msg);		
		}
		
	}
	
	function importWB($wb, $section=1, $category=1) {
	

		$elements = array_keys($wb);

		$wsID = '';
		// Import Worksheets first
		foreach ( $elements as $elem ) {
			echo $elem . '<br>';

			if ( substr( $elem, 0, 10) == 'worksheet_' ) {
				$wsID .= $this->importWS($wb[$elem]) . ',';				
			}
		}
		
		// Import the Workbook

		// Get current __sql2excel_workbooks fields
		$db 		=& JFactory::getDBO();
		$wbFields = $db->getTableFields( array('#__sql2excel_workbooks') );

		if ( count($wbFields) ) {			
			$wbFields = array_shift($wbFields);
			$wbFields = array_keys($wbFields);
			
			$wbElements = array_keys($wb);
			$colNames = array();
			$colValues = array();
			
			foreach ( $wbElements as $col ) {
				if ( in_array($col, $wbFields ) && $col != 'section' && $col != 'category') {
					$colNames[] = '`' . $col . '`';					
					if ( is_numeric($wb[$col]) ) {
						$colValues[] = $wb[$col];
					} elseif ( is_array($wb[$col]) ) {
						// parms comes through as empty array if not defined
						$colValues[] = $db->Quote('');
					} else {
						$colVal = str_replace("@~@", "\r\n", $wb[$col]);
						$colVal = str_replace("@~@", "\n", $colVal);
						$colValues[] = $db->Quote('' . $colVal);
					}					
				}
			}
			$query = 'INSERT INTO #__sql2excel_workbooks (`section`,`category`,' . implode(',', $colNames) . ') VALUES (' . $section . ',' . $category . ',' . implode(',', $colValues) . ')';
			$db->setQuery( $query );
			if ( $db->query() ) {
				// Add Worksheet mapping
				$wbID = $db->insertid();
				if ( $wbID > 0 ) {
					$order=1;
					$wsArr = explode(',', $wsID);
					foreach ( $wsArr as $id ) {
						if ( $id > 0 ) {
							$query = 'INSERT INTO #__sql2excel_worksheet2book (`wb_id`,`ws_id`,`ordering`) VALUES (' . $wbID . ',' . $id . ',' . $order . ')';
							echo $query . '<br>';
							$db->setQuery( $query );
							if ( $db->query() ) {
								$order++;
							}
						}
					}
				}
				
				return true;
			}
			

		}
		
		
		return false;
	
	}
	
	
	function importWS($ws) {
		if ( is_array($ws) && isset($ws['title']) && isset($ws['sheetname']) ) {
		
			// Get current __sql2excel_worksheets fields
			$db 		=& JFactory::getDBO();
			$wsFields = $db->getTableFields( array('#__sql2excel_worksheets') );
			
			if ( count($wsFields) ) {
			
				$wsFields = array_shift($wsFields);
				$wsFields = array_keys($wsFields);			
				$wsElements = array_keys($ws);
				$colNames = array();
				$colValues = array();
				foreach ( $wsElements as $col ) {
					if ( in_array($col, $wsFields ) ) {					
						$colNames[] = '`' . $col . '`';
						if ( $col == "heading_bg_col" && (int) $ws[$col] > 0 ) {
							$ws[$col] = 'silver';
						} elseif ( $col == "heading_text_col" && (int) $ws[$col] > 0 ) {
							$ws[$col] = 'black';
						}						
						if ( is_numeric($ws[$col]) ) {
							$colValues[] = $ws[$col];
						} elseif (is_array($ws[$col]) ) {
							$colValues[] = $db->Quote('');
						} else {						
							$colVal = str_replace("@~@", "\r\n", $ws[$col]);
							$colVal = str_replace("@~@", "\n", $colVal);
							$colValues[] = $db->Quote('' . $colVal);
						}
					}
				}
			
				$query = 'INSERT INTO #__sql2excel_worksheets (`published`,' . implode(',', $colNames) . ') VALUES (1,' . implode(',', $colValues) . ')';
				$db->setQuery( $query );
				if ( $db->query() ) {
					// Return ID of the new worksheet
					return $db->insertid();
				}
			}
		}
		
		// Error => return empty string
		return '';
	}



	function xml2array($url, $get_attributes = 1, $priority = 'tag')
	{
    		$contents = "";
    		if (!function_exists('xml_parser_create'))
    		{
        		return array ();
    		}
    		$parser = xml_parser_create('');
    		if (!($fp = @ fopen($url, 'rb')))
    		{
        		return array ();
    		}
    		while (!feof($fp))
    		{
        		$contents .= fread($fp, 8192);
    		}
   		fclose($fp);
    		xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
    		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
   		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    		xml_parse_into_struct($parser, trim($contents), $xml_values);
    		xml_parser_free($parser);
    		if (!$xml_values)
        		return; //Hmm...
    		$xml_array = array ();
    		$parents = array ();
    		$opened_tags = array ();
    		$arr = array ();
    		$current = & $xml_array;
    		$repeated_tag_index = array ();
    		foreach ($xml_values as $data)
    		{
        		unset ($attributes, $value);
        		extract($data);
        		$result = array ();
        		$attributes_data = array ();
        		if (isset ($value))
        		{
            		if ($priority == 'tag')
                		$result = $value;
            		else
                		$result['value'] = $value;
        		}
        		if (isset ($attributes) and $get_attributes)
        		{
            			foreach ($attributes as $attr => $val)
            			{
                			if ($priority == 'tag')
                    				$attributes_data[$attr] = $val;
                			else
                    				$result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            			}
        		}
        		if ($type == "open")
        		{
            			$parent[$level -1] = & $current;
            			if (!is_array($current) or (!in_array($tag, array_keys($current))))
            			{
                			$current[$tag] = $result;
                			if ($attributes_data)
                    			$current[$tag . '_attr'] = $attributes_data;
                			$repeated_tag_index[$tag . '_' . $level] = 1;
                			$current = & $current[$tag];
            			}
            			else
            			{
                			if (isset ($current[$tag][0]))
                			{
                    			$current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    			$repeated_tag_index[$tag . '_' . $level]++;
                			}
                			else
                			{
                    				$current[$tag] = array (
                        							$current[$tag],
                        							$result
                    							);
                    				$repeated_tag_index[$tag . '_' . $level] = 2;
                    				if (isset ($current[$tag . '_attr']))
                    				{
                        				$current[$tag]['0_attr'] = $current[$tag . '_attr'];
                        				unset ($current[$tag . '_attr']);
                    				}
                			}	
                			$last_item_index = $repeated_tag_index[$tag . '_' . $level] - 1;
                			$current = & $current[$tag][$last_item_index];
            			}
        		}
        		elseif ($type == "complete")
        		{
            			if (!isset ($current[$tag]))
            			{
                			$current[$tag] = $result;
                			$repeated_tag_index[$tag . '_' . $level] = 1;
                			if ($priority == 'tag' and $attributes_data)
                    			$current[$tag . '_attr'] = $attributes_data;
            			}
            			else
            			{
                			if (isset ($current[$tag][0]) and is_array($current[$tag]))
                			{
                    			$current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    			if ($priority == 'tag' and $get_attributes and $attributes_data)
                    			{
                        			$current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                    			}
                    			$repeated_tag_index[$tag . '_' . $level]++;
                			}
                			else
                			{
                    				$current[$tag] = array (
                        						$current[$tag],
                        						$result
                    						);
                    				$repeated_tag_index[$tag . '_' . $level] = 1;
                    				if ($priority == 'tag' and $get_attributes)
                    				{
                        				if (isset ($current[$tag . '_attr']))
                        				{
                            					$current[$tag]['0_attr'] = $current[$tag . '_attr'];
                           			 		unset ($current[$tag . '_attr']);
                        				}
                        				if ($attributes_data)
                        				{
                            					$current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                        				}
                    				}
                    				$repeated_tag_index[$tag . '_' . $level]++; //0 and 1 index is already taken
                			}
            			}
        		}
        		elseif ($type == 'close')
        		{
            			$current = & $parent[$level -1];
        		}
    		}
    		return ($xml_array);
	}	


}