<?php
/**
 * sql2excelworkbook controller for the SQL 2 Excel component
 * 
 * @license		GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );



class Sql2excelControllerSqlexcelworkbook extends Sql2excelController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'accesspublic', 'accessMenu');
		$this->registerTask( 'accessregistered', 'accessMenu');
		$this->registerTask( 'accessspecial', 'accessMenu');
		$this->registerTask( 'exportxml', 'exportXML');
		$this->registerTask( 'importxml', 'importXML');		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		$thismodel = $this->getModel( 'sqlexcelworkbook' );
		$thismodel->checkout();

		JRequest::setVar( 'view', 'sqlexcelworkbook' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}




	/**
	 * Move Section Up
	 * @return void
	 */
	function orderup()
	{
		$model = $this->getModel( 'sqlexcelworkbook' );
		$model->move(-1);

		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect( $link );
	}

	/**
	 * Move Section Down
	 * @return void
	*/
	function orderdown()
	{
		$model = $this->getModel( 'sqlexcelworkbook' );
		$model->move(1);

		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect( $link );
	}

	/**
	 * Apply changes to the record
	 * @return void
	*/
	function apply()
	{
		$this->save();
	}

	/**
	 * Save a record
	 * @return void
	*/
	function save()
	{
		$post  = JRequest::get('post');
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$cid   = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];  // 0 for new, or actual ID when editing
		$model = $this->getModel('sqlexcelworkbook');
		if ( $post['id'] == 0 || $post['id'] == null || $post['id'] == '' || $post['created'] == '' ) {
			$post['created'] =  date('Y-m-d H:i:s');						
		}
		$task = JRequest::getCmd('task');
		$worksheets = $post['worksheets'];

			

		if ( $task == 'apply' ) {
			$id = $model->store($post);
			if ($id && $id > 0) {
				$model->storeWS($id, $worksheets);
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Workbook Changes Saved' );
				} else {
					$msg = JText::_( 'New Workbook Saved' );
				}				
			} else {
				$msg = JText::_( 'Error Saving Workbook' );
			}
			$this->setRedirect( 'index.php?option=com_sql2excel&controller=sqlexcelworkbook&task=edit&cid[]=' . $id, $msg );
		} else {
			$id = $model->store($post);
			if ( $id ) {
				$model->storeWS($id, $worksheets);
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Workbook Changes Saved' );
				} else {
					$msg = JText::_( 'New Workbook Saved' );
				}				
			} else {
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Error Saving Workbook Changes' );
				} else {
					$msg = JText::_( 'Error Saving New Workbook' );
				}
			}
			$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworkbooks', $msg );
		}

	}



	/**
	 * Save Ordering of Categories
	 * @return void
	*/
	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel( 'sqlexcelworkbook' );
		$model->saveorder($cid, $order);

		$msg = JText::_( 'New Workbook order saved' );
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect( $link, $msg  );
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('sqlexcelworkbook');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Categories Could not be Deleted' );
		} else {
			$msg = JText::_( 'Workbook(s) Deleted' );
		}
		$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworkbooks', $msg );
	}

	/**
	 * Method to publish workbook(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function publish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Please select a Workbook to publish' ) );
		}

		$model = $this->getModel('sqlexcelworkbook');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		} else {
			$model->checkin();
		}
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect($link);
	}

	function unpublish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select a Workbook to unpublish' ) );
		}

		$model = $this->getModel('sqlexcelworkbook');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		} else {
			$model->checkin();
		}		
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect($link);
	}

	function accessMenu()
	{
		$post			= JRequest::get('post');
		$cid			= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$access			= $post['task'];
	
		switch ($access)
		{
			case 'accessregistered':
			$access_id= 1;
			break;

			case 'accessspecial':
			$access_id= 2;
			break;
			
			case 'accesspublic':
			default:
			$access_id= 0;
			break;
		}
		
		$model = $this->getModel( 'sqlexcelworkbook' );

		$model->accessmenu($cid[0],$access_id);
		$model->checkin();
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
		$this->setRedirect($link);
	}


	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworkbooks', $msg );
	}
	
	
	/**
	 * Export Workbook(s) to XML file
	 * @return void
	*/
	function exportXML()
	{				 
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Please select a Workbook to export' ) );
		}

		$model = $this->getModel('sqlexcelworkbook');
		if($model->exportXML($cid) ) {
			
			// XML file feed to the browser by the model
			exit;			
		} else {
			echo "<script> alert('". JText::_( 'Failed to export Workbook(s)' ) . "'); window.history.go(-1); </script>\n";
			$link = 'index.php?option=com_sql2excel&view=sqlexcelworkbooks';
			$this->setRedirect( $link, 'EXPORT XML FAILED' );
		}
	}
	

	/**
	 * Import Workbook(s) from XML file
	 * @return void
	*/
	function importXML()
	{	
		$link = 'index.php?option=com_sql2excel&view=sqlexcelimportxml';
		$this->setRedirect( $link );	
	}
	
}