<?php
/**
 * sql2excelworksheet controller for the SQL 2 Excel component
 * 
 * @license		GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );



class Sql2excelControllerSqlexcelworksheet extends Sql2excelController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'accesspublic', 'accessMenu');
		$this->registerTask( 'accessregistered', 'accessMenu');
		$this->registerTask( 'accessspecial', 'accessMenu');
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		$thismodel = $this->getModel( 'sqlexcelworksheet' );
		$thismodel->checkout();

		JRequest::setVar( 'view', 'sqlexcelworksheet' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}




	/**
	 * Move Section Up
	 * @return void
	 */
	function orderup()
	{
		$model = $this->getModel( 'sqlexcelworksheet' );
		$model->move(-1);

		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect( $link );
	}

	/**
	 * Move Section Down
	 * @return void
	*/
	function orderdown()
	{
		$model = $this->getModel( 'sqlexcelworksheet' );
		$model->move(1);

		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect( $link );
	}

	/**
	 * Apply changes to the record
	 * @return void
	*/
	function apply()
	{
		$this->save();
	}

	/**
	 * Save a record
	 * @return void
	*/
	function save()
	{
		$post  = JRequest::get('post');
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$query = $this->utf8_strrev(JRequest::getVar( 'query', '', 'post', 'string', JREQUEST_ALLOWRAW ));		
		$query = str_replace("@~@","\n", $query);		
		$post['query'] = $query;
		$post['header'] = $_POST["header"];  // Needed to maintain new lines in the beginning and end
		$post['footer'] = $_POST["footer"];  // Needed to maintain new lines in the beginning and end
		
		$cid   = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];  // 0 for new, or actual ID when editing
		if ( $post['id'] == 0 || $post['id'] == null || $post['id'] == '' || $post['created'] == '' ) {
			$post['created'] =  date('Y-m-d H:i:s');						
		}
		$model = $this->getModel('sqlexcelworksheet');
		$task = JRequest::getCmd('task');

		if ( $task == 'apply' ) {
			$id = $model->store($post);
			if ($id && $id > 0) {
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Workbook Changes Saved' );
				} else {
					$msg = JText::_( 'New Workbook Saved' );
				}
			} else {
				$msg = JText::_( 'Error Saving Workbook' );
			}
			// if ( (int) $cid[0] > 0 ) { $id = (int) $cid[0]; } 
			$this->setRedirect( 'index.php?option=com_sql2excel&controller=sqlexcelworksheet&task=edit&cid[]=' . $id, $msg );
		} else {
			$id = $model->store($post);
			if ( $id ) {
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Worksheet Changes Saved' );
				} else {
					$msg = JText::_( 'New Worksheet Saved' );
				}
			} else {
				if ( (int) $cid[0] > 0 ) {
					$msg = JText::_( 'Error Saving Worksheet Changes' );
				} else {
					$msg = JText::_( 'Error Saving New Worksheet' );
				}
			}
			$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworksheets', $msg );
		}


	}


	function utf8_strrev($str, $reverse_numbers = true){
    		$pattern = $reverse_numbers ? '/./us' : '/(\d+)?./us';
    		preg_match_all($pattern, $str, $ar);
    		return join('',array_reverse($ar[0]));
	}
	

	/**
	 * Save Ordering of Categories
	 * @return void
	*/
	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel( 'sqlexcelworksheet' );
		$model->saveorder($cid, $order);

		$msg = JText::_( 'New Worksheet order saved' );
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect( $link, $msg  );
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('sqlexcelworksheet');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Categories Could not be Deleted' );
		} else {
			$msg = JText::_( 'Worksheet(s) Deleted' );
		}
		$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworksheets', $msg );
	}

	/**
	 * Method to publish worksheet(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function publish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Please select a Worksheet to publish' ) );
		}

		$model = $this->getModel('sqlexcelworksheet');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		} else {
			$model->checkin();
		}
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect($link);
	}

	function unpublish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select a Worksheet to unpublish' ) );
		}

		$model = $this->getModel('sqlexcelworksheet');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		} else {
			$model->checkin();
		}		
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect($link);
	}

	function accessMenu()
	{
		$post			= JRequest::get('post');
		$cid			= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$access			= $post['task'];
	
		switch ($access)
		{
			case 'accessregistered':
			$access_id= 1;
			break;

			case 'accessspecial':
			$access_id= 2;
			break;
			
			case 'accesspublic':
			default:
			$access_id= 0;
			break;
		}
		
		$model = $this->getModel( 'sqlexcelworksheet' );

		$model->accessmenu($cid[0],$access_id);
		$model->checkin();
		$link = 'index.php?option=com_sql2excel&view=sqlexcelworksheets';
		$this->setRedirect($link);
	}


	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_sql2excel&view=sqlexcelworksheets', $msg );
	}
}