<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(JPATH_SITE.DS.'components'.DS.'com_sql2excel'.DS.'helpers'.DS.'excel_writer.php');
require_once( JPATH_COMPONENT.DS.'controllers'.DS.'download.php' );
require_once(JPATH_SITE.DS.'components'.DS.'com_sql2excel'.DS.'helpers'.DS.'parms.php');

class Sql2excelCommon
{
	function getWorksheets($wb_id) 
	{

		$db 		=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$aid 		= $user->get('aid', 0);	


		$wheres[] = " a.id = " . (int) $wb_id;	
		$wheres[] = " a.id = b.wb_id ";
		$wheres[] = " b.ws_id = c.id ";
		//$wheres[] = " a.published=1 ";
		$wheres[] = " c.published=1 ";
		$wheres[] = " a.section=d.id ";
		$wheres[] = " a.category=e.id ";
		$wheres[] = " e.published=1 ";


		if ($aid !== null) {
			$wheres[] = "a.access <= " . (int) $aid;
			$wheres[] = "c.access <= " . (int) $aid;
			$wheres[] = "d.access <= " . (int) $aid;
			$wheres[] = "e.access <= " . (int) $aid;
		}


		$query = " SELECT c.id, c.sheetname, a.link_title as wbtitle " .
			 " FROM #__sql2excel_workbooks a, #__sql2excel_worksheet2book b, #__sql2excel_worksheets c, #__sql2excel_sections d, #__sql2excel_categories e " .
			 " WHERE " . implode( " AND ", $wheres ) .
			 " ORDER BY b.ordering";
			 
		$db->setQuery( $query );
		$worksheets = $db->loadObjectList();
		
		return $worksheets;
	}
	
	
	function getWorkbookParms($wb_id) 
	{
		global $mainframe;
		
		$db 		=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$aid 		= $user->get('aid', 0);	


		$wheres[] = " a.id = " . (int) $wb_id;	
		$wheres[] = " a.id = b.wb_id ";
		$wheres[] = " b.ws_id = c.id ";
		//$wheres[] = " a.published=1 ";
		$wheres[] = " c.published=1 ";
		$wheres[] = " a.section=d.id ";
		$wheres[] = " a.category=e.id ";
		$wheres[] = " e.published=1 ";


		if ($aid !== null) {
			$wheres[] = "a.access <= " . (int) $aid;
			$wheres[] = "c.access <= " . (int) $aid;
			$wheres[] = "d.access <= " . (int) $aid;
			$wheres[] = "e.access <= " . (int) $aid;
		}


		$query = " SELECT a.parms, a.parms_prompt " .
			 " FROM #__sql2excel_workbooks a, #__sql2excel_worksheet2book b, #__sql2excel_worksheets c, #__sql2excel_sections d, #__sql2excel_categories e " .
			 " WHERE " . implode( " AND ", $wheres );
			 
		$db->setQuery( $query );
		//$wbParms = $db->loadResult();
		$parmInfo = $db->loadObjectList();
		if ( count($parmInfo) ) {
			$parmInfo = $parmInfo[0];
			$wbParms = $parmInfo->parms;
			$wbParmsPrompt = $parmInfo->parms_prompt;
		}
		
		if ( $wbParms == '' ) {
			return '';
		} else {
			
			// Component Configuration Parameters
			//$cmpParms = &$mainframe->getParams();
			//$cmpParms =& JComponentHelper::getParams( 'com_sql2excel' );
			$cmpParms 	= Sql2excelParms::getParms();
			//$substWBParms = $cmpParms->get( 'subst_wbparms', '1' );
			$substWBParms = Sql2excelParms::get($cmpParms,'subst_wbparms', '1');
			
			
			$wbParmVars = '';
			$wbParmVarsAdd = '';
			$wbParmvalidate = '';
			$wbHiddenParms = '';
			$wbValidate = '';
			$nrWbParms = 0;
			
			// Workbook Parameters defined
			$wbParmsHTML = '<div style="margin-bottom: 20px;">';
			$wbParmsHTML .= '<fieldset>';
			$wbParmsHTML .= '<legend>' .  JText::_( 'Parameters') . '</legend>';
			$wbParmsHTML .= '<table>';

			$i=1;				
			$parmsArr = explode('~@~',$wbParms);
			foreach ($parmsArr as $parm) {
				$parmTokens = explode(',', $parm);
				$wbParmsHTML .= '<tr>';
				$wbParmsHTML .= '<td><b>' . $parmTokens[0] . '</b></td>';
				$wbParmsHTML .= '<td> : </td>';
				if ( $substWBParms ) {
					// Get common substitution variables (for default value substitution)
					$substParms = Sql2excelControllerDownload::getSubstParms();				
					$defaultValue = writeExcel::replace_vars($parmTokens[3], $substParms);
				} else {				
					$defaultValue = $parmTokens[3];
				}
				$wbParmsHTML .= '<td><input type="text" id="parm' . $i . '" value="'.$defaultValue . '"></td>';
				$wbParmsHTML .= '</tr>';
				$wbParmVars .= "var parm" . $i . "H=document.getElementById('parm" . $i . "');\n";
				$wbParmVars .= "var parm" . $i . "=parm" . $i . "H.value;\n";
				$wbParmVarsAdd .= '&parm' . $i . '=\' +  urlencode(parm' . $i . ") + '";
				$wbHiddenParms .= "<input type=\"hidden\" name=\"wbparm" . $i . "\" id=\"wbparm" . $i . "\" value=\"" . urlencode($defaultValue) . "\">\n";
				$wbValidate  .= '~@~parm' . $i . ',' . $parmTokens[0] . ',' . $parmTokens[2];
				$i++;										
			}
				
			$nrWbParms = $i-1;
				
			$wbParmsHTML .= '</table>';
			$wbParmsHTML .= '</fieldset>';
			$wbParmsHTML .= '</div>';
			
			if ( $wbValidate != '' ) {
				$wbValidate = substr($wbValidate,3);
				$wbValidate = "if ( !validateParms(\"" . $wbValidate . "\") ) {\n";
				$wbValidate .= "   return false;\n";
				$wbValidate .= "}\n";
			}
			
			$wbRefresh = "<input type=\"button\" value=\"&nbsp;&nbsp;" . JText::_( 'Refresh') . "&nbsp;&nbsp;\" onClick=\"UpdateTab(currTabH,currWS,1);\">&nbsp;&nbsp;&nbsp;";
			
			if ( $wbParmsPrompt ) {
				return array($wbParmsHTML, $wbParmVars, $wbParmVarsAdd, $wbHiddenParms, $nrWbParms, $wbRefresh, $wbValidate);
			} else {
				return array('', '', '', $wbHiddenParms, 0, '', '');
			}
			
		}
	}

}
?>