<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel
 * @copyright Copyright (C) Joomla-R-Us, Joomla-R-Us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
 
class Sql2excelControlPanel
{
	function addButton( $link, $image, $text ) {
		
		$button = '<div style="float:left;">';
		$button .= '<div class="icon">'
				   .'<a href="'.$link.'">'
				   .JHTML::_('image.site',  $image, '/components/com_sql2excel/assets/images/', NULL, NULL, $text )
				   .'<span>'.$text.'</span></a>'
				   .'</div></div>';
		return $button;
	}
	
	function addLogo( ) {
		
		$button = '';
		$button .= '<div class="icon">'
				   .'<a href="http://Joomla-R-Us.com">'
				   .JHTML::_('image.site',  'Joomla-R-Us-logo.gif', '/components/com_sql2excel/help/en-GB/', NULL, NULL, 'Joomla-R-Us' )
				   .'</a>'
				   .'</div>';
		return $button;
	}
	
	
	function getVersion($defaultVer) {
	
		$version = $defaultVer;		
		$xmlFN = JPATH_ADMINISTRATOR .DS. 'components'.DS.'com_sql2excel'.DS.'install.xml';
		if ( file_exists($xmlFN) ) {
			$xmltokens = JApplicationHelper::parseXMLInstallFile($xmlFN);
			if ( is_array($xmltokens ) ) {
				if ( isset( $xmltokens{'version'} ) ) {
					$version = $xmltokens{'version'};
				}
			}
		}		
		return $version;
	}


	/**
	 * Method to get check if a upgrade is needed
	 * @return empty string if no upgrade is needed. returns upgrade message if it is needed.
	 */
	function upgradeMessage() {

		$upgrade =	'<div id="upgrade" style="border: 3px solid; border-color: red; padding: 20px; margin: 10px;">
				<h1 style="color: red;">' . JText::_( 'UPGRADE NEEDED!' ) . '</h1>
				<p><b>' . JText::_('A previous version of SQL 2 Excel is detected. An upgrade of the SQL 2 Excel table structure is needed in order to use this version of SQL 2 Excel with your existing table data. Click on the button below to perform the upgrade.') . '</b><br></p>
				<p><br> <br><a href="index.php?option=com_sql2excel&controller=sqlexcelupgrade&task=upgrade"><img src="' . JURI::base() . 'components/com_sql2excel/assets/images/upgrade_now.png"></a></p>
				</div>';
				
		// Version 0.9.2 - Check #__sql2excel_worksheets columns  (20)
		// Version 1.1.5 - Check #__sql2excel_worksheets columns  (23)
		// Version 1.5.0 - Check #__sql2excel_worksheets columns  (26)
		$db	= & JFactory::getDBO();		
		$query = 'SHOW COLUMNS FROM #__sql2excel_worksheets';
		$db->setQuery( $query );
		$ws_cols = $db->loadObjectList();
		
		// Version 1.1.4 - Check #__sql2excel_workbooks columns
		$query = 'SHOW COLUMNS FROM #__sql2excel_workbooks';
		$db->setQuery( $query );
		$wb_cols = $db->loadObjectList();

		if ( count($ws_cols) < 27 || count($wb_cols) < 15 ) {
			return $upgrade;
		} else {
			// Version 1.4.0
			if ( ! Sql2excelControlPanel::tableExists('#__sql2excel_settings') ) {
				return $upgrade;
			} else {
				return '';
			}
		}
	}
	
	
	function tableExists($tableName) {
		$db	= & JFactory::getDBO();	
		$prefix = $db->_table_prefix;
		$tableName = str_replace('#__', $prefix, $tableName);
		$tableList = $db->getTableList($db);		
		if ( in_array($tableName,$tableList) ) {
			return true;
		} else {
			return false;
		}
	}	


}
