<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');


class Sql2excelModelSqlexcelcategory extends JModel
{
	var $_catID;
	var $_catData;

	/**
	 * Constructor that retrieves the ID from the request
	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_catID		= $id;
		$this->_catData	= null;
	}

	/**
	 * Method to get list of Sections
	 * @return object with data
	 */
	function getSectionOptions($selected)
	{
		// Get list of sections
		$db	= & JFactory::getDBO();		
		$query = ' SELECT ID AS value, TITLE AS text ' .
			 ' FROM #__sql2excel_sections ' .
			 ' ORDER BY TITLE';
		$this->_db->setQuery( $query );
		$mysections[] = JHTML::_('select.option', '0', '- '.JText::_('Please Select').' -');
		$sections = array_merge($mysections, $db->loadObjectList());
		$sectionsOpt = JHTML::_( 'select.genericlist', 
					 $sections, 
					 'section',  
					 'class="inputbox" size="1" onChange="check_required(\'section_req_div\',this, \'0\');"' , 
					 'value', 
					 'text',
					 $selected );
		return $sectionsOpt;
	}

	/**
	 * Method to get data
	 * @return object with data
	 */
	function &getData()
	{

		// Load the data
		if (empty( $this->_catData )) {
			$query = ' SELECT * FROM #__sql2excel_categories ' .
				 ' WHERE id = '.$this->_catID;
			$this->_db->setQuery( $query );
			$this->_catData = $this->_db->loadObject();
		}
		if (!$this->_catData) {
			$sql2excel = new stdClass();
			$sql2excel->id			= 0;
			$sql2excel->parent_id		= null;
			$sql2excel->section		= null;
			$sql2excel->title		= null;
			$sql2excel->alias		= null;
			$sql2excel->description		= null;
			$sql2excel->published		= 1;
			$sql2excel->checked_out		= 0;
			$sql2excel->checked_out_time	= null;
			$sql2excel->ordering		= 0;
			$sql2excel->access		= 0;
			$sql2excel->count		= 0;
			$this->_catData		= $sql2excel;
		}
		return $this->_catData;
	}
	
	/**
	 * Method to check if a category is checked out or not
	 *
	 * @access	public
	 * @return	boolean	True if it is checked out
	 */
	function isCheckedOut( $uid=0 ) {
		if ($this->_loadData()) {
			if ($uid) {
				return ($this->_catData->checked_out && $this->_catData->checked_out != $uid);
			} else {
				return $this->_catData->checked_out;
			}
		}
	}

	/**
	 * Method to checkin a category
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function checkin() {
		if ($this->_catID ) {
			$cattable = & $this->getTable();
			if(! $cattable->checkin($this->_catID)) {
				$this->setError('<p>Checkin failed!</p><p>' . $this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	/**
	 * Method to checkout a category
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function checkout($uid = null) {
		if ($this->_catID )
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$cattable = & $this->getTable();
			if(!$cattable->checkout($uid, $this->_catID)) {
				$this->setError('<p>Checkout failed!</p><p>' . $this->_db->getErrorMsg() );
				return false;
			}
			return true;
		}
		return false;
	}


	/**
	 * Method to move category up or down
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function move($direction) {
		$row =& $this->getTable();
		if (!$row->load($this->_catID)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->move( $direction, ' published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}

	/**
	 * Method to publish category(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__sql2excel_categories'
				. ' SET published = '. (int) $publish
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

 	/**
	 * Method to reorder the categories
	 *
	 * @access	public
	 * @return	void
	*/
	function saveorder($cid = array(), $order) {
		$row 	=& $this->getTable();
		$total	= count( $cid );

		// update ordering values
		for( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
		$row->reorder( );
	}

 	/**
	 * Method to store a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	*/
	function store($data)
	{	
		$row =& $this->getTable();

		// Bind the form fields to the #__sql2excel_categories table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}

		return $row->id;
	}

	/**
	 * Method to update item access
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function accessmenu($id, $access)
	{
		global $mainframe;
		$row =& $this->getTable();
		$row->load($id);
		$row->id = $id;
		$row->access = $access;
		if ( !$row->check() ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		if ( !$row->store() ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}


	/**
	 * Method to delete record(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		


		if (count( $cids )) {
		
			$row =& $this->getTable();

			// Check that there are no Workbooks assigned to the category(ies)
			$cidStr = implode( ',', $cids );
		
			$query = 'SELECT category, COUNT(*) AS cnt ' .
			' FROM #__sql2excel_workbooks ' .
			' WHERE category IN (' . $cidStr . ') ' . 
			' GROUP BY category';

			
			$db	= & JFactory::getDBO();		
			$db->setQuery($query);
			$wbCounts = $db->loadObjectList();	
			
			$errIds = "";			
			foreach($cids as $cid) {
				$err = 0;
				foreach ($wbCounts as $w ) {
					if ( $w->category == $cid && $w->cnt > 0 ) {
						$err=1;
						$errIds=$errIds . "," . $cid;
					}
				}
				if ( $err == 0 ) {
					if (!$row->delete( $cid )) {
						$this->setError( $row->getErrorMsg() );
						return JText::_('Error deleting Category!');
					}
				} 
			}
			
			if ( $errIds == "" ) {
				return JText::_('Category(s) Deleted');			
			} else {
				return JText::_('One or more categories could not be deleted. There are still workbook(s) mapped to this category ') . ': '. $errIds;
			}

		}


		return '';
	}

	/**
	 * Method to retrieve current category record
	 *
	 * @access	Private
	 * @return	boolean	True on success
	 */
	function _getData() {
		if (empty($this->_catData)) {		
			$query = 'SELECT p.* '.	
					' FROM #__sql2excel_categories' .
					' WHERE id = ' . (int) $this->_catID;
			$this->_db->setQuery($query);
			$this->_catData = $this->_db->loadObject();
			return (boolean) $this->_catData;
		}
		return true;
	}

}