<?php
/*
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');


class Sql2excelModelSqlexcelimportxml extends JModel
{
	var $_wbID;
	var $_wbData;

	/**
	 * Constructor that retrieves the ID from the request
	 */
	function __construct()
	{
		parent::__construct();
	}

	/**
	 * Method to get list of Sections
	 * @return select list (html)
	 */
	function getSectionOptions($selected)
	{
		// Get list of sections
		$db	= & JFactory::getDBO();		
		$query = ' SELECT ID AS value, TITLE AS text ' .
			 ' FROM #__sql2excel_sections ' .
			 ' ORDER BY TITLE';
		$this->_db->setQuery( $query );
		$mysections[] = JHTML::_('select.option', '0', '- '.JText::_('Please Select').' -');
		$sections = array_merge($mysections, $db->loadObjectList());
		$sectionsOpt = JHTML::_( 'select.genericlist', 
					 $sections, 
					 'section',  
					 'class="inputbox" size="1" onchange="changeDynaList( \'category\', categoryArray, document.adminForm.section.options[document.adminForm.section.selectedIndex].value, 0, 0);"', 
					 'value', 
					 'text',
					 $selected );
		return $sectionsOpt;
	}

	/**
	 * Method to get list of Categories
	 * @return select list (html)
	 */
	function getCategoryOptions($sectionid, $catid)
	{
	
		// Get list of categories for the selected section
		$mycategories[] = JHTML::_('select.option', '0', '- '.JText::_('Please Select').' -');
		if ( $sectionid > 0 ) {
			$db	= & JFactory::getDBO();		
			$query = ' SELECT ID AS value, TITLE AS text ' .
			 	' FROM #__sql2excel_categories ' .
			 	' WHERE section=' . $sectionid  .
			 	' ORDER BY TITLE';
			$this->_db->setQuery( $query );
		
			$categories = array_merge($mycategories, $db->loadObjectList());
		} else { $categories = $mycategories; }
		
		$categoryOpt = JHTML::_( 'select.genericlist', 
					 $categories, 
					 'category',  
					 'class="inputbox" size="1"' , 
					 'value', 
					 'text',
					 $catid );
		return $categoryOpt;
	}


	/**
	 * Method to get Javascript array with all Categories vs Sections
	 * @return Javascript snippet
	 */
	function getCategoryArray()
	{
	
		// Get list of categories for the selected section
		$mycategories = "var categoryArray = new Array;\ncategoryArray[0] = new Array( '0','0','- Please Select -' );";


		$db	= & JFactory::getDBO();		
		$query = ' SELECT ID, TITLE, SECTION ' .
			 	 ' FROM #__sql2excel_categories ' .
			 	 ' ORDER BY SECTION, TITLE';
		$this->_db->setQuery( $query );
		
		$categories = $db->loadObjectList();
		$i=1;
		foreach ( $categories as $cat ) {
			$mycategories = $mycategories . "\ncategoryArray[" . $i . "]=new Array('" . $cat->SECTION . "','" . $cat->ID . "','" . str_replace("'", '',$cat->TITLE) . "');"; 
			$i++;
		}		
		return $mycategories;
	}
	

}