<?php
/*
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 */
 
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_sql2excel'.DS.'helpers'.DS.'sql2excel.php' );

class Sql2excelModelSqlexcelsettings extends JModel
{
	var $_wbID;
	var $_wbData;

	/**
	 * Constructor that retrieves the ID from the request
	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_wbID		= $id;
		$this->_wbData	= null;
	}




	/**
	 * Method to get list of Worksheets
	 * @return select list (html)
	 */
	function getWorksheetList($id, $width)
	{
		if ( $width == '' ) { $width = 300; };

		// Get list of sections
		$db	= & JFactory::getDBO();	
		if ( $id == 0 ) {
			$query = " SELECT ID AS value, CONCAT(ID, ' : ', TITLE, ' : ', sheetname ) AS text " .
			 	' FROM #__sql2excel_worksheets ' .
			 	' ORDER BY ID';
		} else {
			$query = " SELECT ID AS value, CONCAT(ID, ' : ', TITLE, ' : ', sheetname ) AS text " .
			 	' FROM #__sql2excel_worksheets ' .
			 	' WHERE ID NOT IN ( 	SELECT ws_id AS ID 
			 				FROM #__sql2excel_worksheet2book
			 				WHERE wb_id=' . $id . ') ' .
			 	' ORDER BY ID';
		
		}
		$this->_db->setQuery( $query );
		$workSheets = JHTML::_( 'select.genericlist', 
					 $db->loadObjectList(), 
					 'available_worksheets',  
					 'class="inputbox" style="width: ' . $width . 'px" size="20" onDblClick="addWS();"', 
					 'value', 
					 'text');
		return $workSheets;
	}


	/**
	 * Method to get list of Worksheets for a Workbook
	 * @return select list (html)
	 */
	function getSelWorksheetList($currWBid, $width)
	{
		if ( $width == '' ) { $width = 300; };
		
		// Get list of sections
		$db	= & JFactory::getDBO();		
		$query = " SELECT a.ID AS value, CONCAT(a.ID, ' : ', a.TITLE, ' : ', a.sheetname ) AS text " .
			 ' FROM #__sql2excel_worksheets a, #__sql2excel_worksheet2book b' .
			 ' WHERE a.id = b.ws_id AND b.wb_id=' . $currWBid .
			 ' ORDER BY b.ordering';
		$this->_db->setQuery( $query );
		$workSheets = JHTML::_( 'select.genericlist', 
					 $db->loadObjectList(), 
					 'selected_worksheets',  
					 'class="inputbox" style="width: ' . $width . 'px" size="20" onDblClick="remWS();"', 
					 'value', 
					 'text');

		return $workSheets;
	}
	
	

	/**
	 * Method to get data
	 * @return object with data
	 */
	function &getData()
	{

		// Load the data
		if (empty( $this->_wbData )) {
			$query = ' SELECT * FROM #__sql2excel_workbooks ' .
				 ' WHERE id = '.$this->_wbID;
			$this->_db->setQuery( $query );
			$this->_wbData = $this->_db->loadObject();
		}
		if (!$this->_wbData) {
			$sql2excel = new stdClass();
			$sql2excel->id			= 0;
			$sql2excel->title		= null;
			$sql2excel->link_title		= null;
			$sql2excel->filename		= null;
			$sql2excel->section		= null;
			$sql2excel->category		= null;
			$sql2excel->published		= 1;
			$sql2excel->checked_out		= 0;
			$sql2excel->checked_out_time	= null;	
			$sql2excel->created		= null;	
			$sql2excel->access		= 0;		
			$sql2excel->count		= 0;
			$sql2excel->ordering		= 0;
			$sql2excel->parms		= null;
			$sql2excel->parms_prompt	= 1;
			$sql2excel->description		= null;
			$sql2excel->keywords		= null;
			$sql2excel->cache		= 'Global';
			$this->_wbData		= $sql2excel;  
		}
		return $this->_wbData;
	}
	  


	/**
	 * Method to get list Excel Writer types
	 * @return select list (html)
	 */
	function getExcelWriter($name, $selected)
	{
	
		$mytypes[] = JHTML::_('select.option', 'auto', JText::_( 'Auto detect'));
		$mytypes[] = JHTML::_('select.option', '2000_utf8', JText::_( 'Excel 97/2000 - UTF8'));
		$mytypes[] = JHTML::_('select.option', '2000_limited', JText::_( 'Excel 97/2000 - Limited Character Set Support'));
		$typesOpt = JHTML::_( 'select.genericlist', 
					 $mytypes, 
					 $name,  
					 'class="inputbox" size="1"', 
					 'value', 
					 'text',
					 $selected );
		return $typesOpt;
	}
	

	

	/**
	 * Method to get list of Formulas in Preview settings
	 * @return select list (html)
	 */
	function getFormulasPreview($name, $selected)
	{
	
		$mytypes[] = JHTML::_('select.option', 'Show', JText::_( 'Show Full Formula Syntax'));
		$mytypes[] = JHTML::_('select.option', 'Label', JText::_( 'Show #FORMULA Label'));
		$mytypes[] = JHTML::_('select.option', 'Hide', JText::_( 'Hide'));
		$typesOpt = JHTML::_( 'select.genericlist', 
					 $mytypes, 
					 $name,  
					 'class="inputbox" size="1"', 
					 'value', 
					 'text',
					 $selected );
		return $typesOpt;
	}
	

	/**
	 * Method to get Section List Ordering Options
	 * @return select list (html)
	 */
	function getSectionListOrdering($name, $selected, $includeDate = false)
	{
	
		$mytypes[] = JHTML::_('select.option', '1', JText::_( 'Ordering ASC'));
		$mytypes[] = JHTML::_('select.option', '2', JText::_( 'Ordering DESC'));
		$mytypes[] = JHTML::_('select.option', '3', JText::_( 'Title ASC'));
		$mytypes[] = JHTML::_('select.option', '4', JText::_( 'Title DESC'));
		if ( $includeDate ) {
			$mytypes[] = JHTML::_('select.option', '5', JText::_( 'Date ASC'));
			$mytypes[] = JHTML::_('select.option', '6', JText::_( 'Date DESC'));
		}
		$mytypes[] = JHTML::_('select.option', '7', JText::_( 'Id ASC'));
		$mytypes[] = JHTML::_('select.option', '8', JText::_( 'Id DESC'));
				
		$typesOpt = JHTML::_( 'select.genericlist', 
					$mytypes, 
					$name,  
					'class="inputbox" size="1"', 
					'value', 
					'text',
					$selected );
		return $typesOpt;
	}
	


	/**
	 * Method to get list of Preview Modes
	 * @return select list (html)
	 */
	function getPreviewModes($name, $selected)
	{
	
		$mytypes[] = JHTML::_('select.option', 'popup', JText::_( 'New Window - No Template'));
		$mytypes[] = JHTML::_('select.option', 'popupwt', JText::_( 'New Window - With Template'));
		$mytypes[] = JHTML::_('select.option', 'inline', JText::_( 'Same Window - No Template'));
		$mytypes[] = JHTML::_('select.option', 'inlinewt', JText::_( 'Same Window - With Template'));
		$typesOpt = JHTML::_( 'select.genericlist', 
					 $mytypes, 
					 $name,  
					 'class="inputbox" size="1"', 
					 'value', 
					 'text',
					 $selected );
		return $typesOpt;
	}


	/**
	 * Method to get list of Preview Modes
	 * @return select list (html)
	 */
	function getDescriptionOpts($name, $selected)
	{
	
		$mytypes[] = JHTML::_('select.option', '0', JText::_( 'None'));
		$mytypes[] = JHTML::_('select.option', '1', JText::_( 'Top'));
		$mytypes[] = JHTML::_('select.option', '2', JText::_( 'Bottom'));
		$typesOpt = JHTML::_( 'select.genericlist', 
					$mytypes, 
					$name,  
					'class="inputbox" size="1"', 
					'value', 
					'text',
					$selected );
		return $typesOpt;
	}
	
	/**
	 * Method to get list of Theme Options
	 * @return select list (html)
	 */
	function getThemeOpts($name, $selected )
	{	
			$mytypes[] = JHTML::_('select.option', 'sql2excel-olive', JText::_( 'Olive'));
			$mytypes[] = JHTML::_('select.option', 'sql2excel-silver-grad', JText::_( 'Silver Gradient'));			
			$mytypes[] = JHTML::_('select.option', 'sql2excel-tealblue', JText::_( 'Teal Blue'));			

			$typesOpt = JHTML::_( 'select.genericlist', 
					$mytypes, 
					$name,  
					'class="inputbox" size="1"', 
					'value', 
					'text',
					$selected );
		return $typesOpt;
	}
	
	
	
	/**
	 * Method to check if a workbook is checked out or not
	 *
	 * @access	public
	 * @return	boolean	True if it is checked out
	 */
	function isCheckedOut( $uid=0 ) {
		if ($this->_loadData()) {
			if ($uid) {
				return ($this->_wbData->checked_out && $this->_wbData->checked_out != $uid);
			} else {
				return $this->_wbData->checked_out;
			}
		}
	}

	/**
	 * Method to checkin a workbook
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function checkin() {
		if ($this->_wbID ) {
			$cattable = & $this->getTable();
			if(! $cattable->checkin($this->_wbID)) {
				$this->setError('<p>Checkin failed!</p><p>' . $this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	/**
	 * Method to checkout a workbook
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function checkout($uid = null) {
		if ($this->_wbID )
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$cattable = & $this->getTable();
			if(!$cattable->checkout($uid, $this->_wbID)) {
				$this->setError('<p>Checkout failed!</p><p>' . $this->_db->getErrorMsg() );
				return false;
			}
			return true;
		}
		return false;
	}


	/**
	 * Method to move workbook up or down
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function move($direction) {
		$row =& $this->getTable();
		if (!$row->load($this->_wbID)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->move( $direction, ' published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}



	/**
	 * Method to publish workbook(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__sql2excel_workbooks'
				. ' SET published = '. (int) $publish
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

 	/**
	 * Method to reorder the categories
	 *
	 * @access	public
	 * @return	void
	*/
	function saveorder($cid = array(), $order) {
		$row 	=& $this->getTable();
		$total	= count( $cid );

		// update ordering values
		for( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
		$row->reorder( );
	}

 	/**
	 * Method to store a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	*/
	function store($data)
	{	
		
		$db	= & JFactory::getDBO(); 		
		$keys = array_keys($data);
		foreach ($keys as $key) {
			if ( $key != 'task' && $key != 'controller' && $key != 'option' && strlen($key) < 30 ) {
				$query = 'UPDATE #__sql2excel_settings SET `value`=' . $db->Quote($data[$key]) . ' WHERE `param`=' . $db->Quote( $key);
				$db->setQuery($query);
				$db->query();
				echo $query;
			}
		}
		return true;
	}
	

	/**
	 * Method to update item access
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function accessmenu($id, $access)
	{
		global $mainframe;
		$row =& $this->getTable();
		$row->load($id);
		$row->id = $id;
		$row->access = $access;
		if ( !$row->check() ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		if ( !$row->store() ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}


	/**
	 * Method to delete record(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable();

		if (count( $cids )) {
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}
		}
		return true;
	}

	/**
	 * Method to retrieve current workbook record
	 *
	 * @access	Private
	 * @return	boolean	True on success
	 */
	function _getData() {
		if (empty($this->_wbData)) {		
			$query = 'SELECT p.* '.	
					' FROM #__sql2excel_workbooks' .
					' WHERE id = ' . (int) $this->_wbID;
			$this->_db->setQuery($query);
			$this->_wbData = $this->_db->loadObject();
			return (boolean) $this->_wbData;
		}
		return true;
	}
	
		

}