CREATE TABLE IF NOT EXISTS `#__sql2excel_sections` (
  `id` int(11) NOT NULL auto_increment,
  `title` VARCHAR(255) NOT NULL,
  `alias` VARCHAR(255) NOT NULL, 
  `description` TEXT, 
  `published` TINYINT(1) unsigned NOT NULL DEFAULT 0,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` INT(11) NOT NULL DEFAULT 0,
  `access` tinyint(3) unsigned NOT NULL default 0,
  `count` int(11) NOT NULL default '0',  
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__sql2excel_categories` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default 0,
  `section` int(11) NOT NULL default 0,
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) unsigned NOT NULL default 0,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00', 
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default 0,
  `count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `category_idx` (`section`,`published`,`access`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__sql2excel_worksheets` (
  `id` int(11) NOT NULL auto_increment,
  `title` VARCHAR(255) NOT NULL,
  `sheetname` VARCHAR(30) NOT NULL default '',
  `published` tinyint(1) unsigned NOT NULL default 0,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00', 
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `access` tinyint(3) unsigned NOT NULL default 0,  
  `header` TEXT,
  `header_parms` VARCHAR(255) NOT NULL default 'Arial,10,normal,black,none',
  `heading_bg_col` VARCHAR(20) NOT NULL default 'grey',
  `heading_text_col` VARCHAR(20) NOT NULL default 'black',
  `heading_text_size` tinyint(3)  NOT NULL default 10,
  `data_parms` VARCHAR(255) NOT NULL default 'Arial,10,normal,black,None,none,1,silver,1',    
  `colwidths` TEXT,
  `footer` TEXT,
  `footer_parms` VARCHAR(255) NOT NULL default 'Arial,10,normal,black,none',  
  `count` int(11) NOT NULL default '0',
  `include_no_records` tinyint(1) unsigned NOT NULL default 1, 
  `error_norecords` varchar(255),
  `query` TEXT NOT NULL,
  `ordering` int(11) NOT NULL default '0',
  `formulas` VARCHAR(255) NOT NULL default '',
  `preview_rows` int(11) unsigned default NULL,
  `preview_formulas` ENUM('Global','Show','Label','Hide') NOT NULL default 'Global', 
  `preview_hidecols` VARCHAR(255) NOT NULL default '', 
  `print_parms` VARCHAR(255) NOT NULL default '0.75,0.75,1.0,1.0,0,0,0,0,0',  
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__sql2excel_workbooks` (
  `id` int(11) NOT NULL auto_increment,
  `title` VARCHAR(100) NOT NULL, 
  `link_title` VARCHAR(255) NOT NULL, 
  `filename` VARCHAR(255) NOT NULL, 
  `section` int(11) NOT NULL default 0,
  `category` int(11) NOT NULL default 0,    
  `published` TINYINT NOT NULL DEFAULT 0,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',  
  `created` datetime NOT NULL default '0000-00-00 00:00:00',  
  `access` tinyint(3) unsigned NOT NULL default 0,  
  `ordering` int(11) NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `description` text NOT NULL default '',
  `keywords` VARCHAR(255) NOT NULL default '',  
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__sql2excel_worksheet2book` (
  `id` int(11) NOT NULL auto_increment,
  `wb_id` int(11) NOT NULL,
  `ws_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `wb_id` (`wb_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;  
  

CREATE TABLE IF NOT EXISTS `#__sql2excel_settings` (
  `param` varchar(40) NOT NULL,
  `value` TEXT NOT NULL default '',
  PRIMARY KEY  (`param`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;