<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );


class Sql2excelViewSqlexcelsection extends JView
{

	function display($tpl = null)
	{
		global $mainframe;
		
		JHTML::stylesheet( 'sql2excel.css', 'administrator/components/com_sql2excel/assets/' );

		// Get data from the model
		$model	=& $this->getModel();	
		$sql2excel	= & $this->get( 'Data');


		$this->assignRef('sql2excel',$sql2excel);


		$required = '&nbsp;&nbsp;<img src="components/com_sql2excel/assets/images/required.gif" alt="' . JText::_( 'Required' ) . '">';
		$this->assignRef('required',$required);


		// Set toolbar items for the page
		$isNew	= ( $sql2excel->id < 1 );
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'SQL 2 Excel : Sections' ).' : ' . $text . ' : Section', 'sql2excelsections');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		
		$editor =& JFactory::getEditor();

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__sql2excel_sections'
			. ' ORDER BY ordering';
		$extradata['ordering'] 			= JHTML::_('list.specificordering',  $sql2excel, $sql2excel->id, $query, false );

		// build the html select list
		$extradata['published'] 		= JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $sql2excel->published );
		
		$extradata['access'] 			= JHTML::_('list.accesslevel',  $sql2excel );		

		$this->assignRef('extradata', $extradata);
		$this->assignRef('editor', $editor);

		parent::display($tpl);
	}
}