<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_sql2excel'.DS.'helpers'.DS.'sql2excel.php' );

class Sql2excelViewSqlexcelsections extends JView
{

	function display($tpl = null)
	{
	
		// Upgrade Message?
		$upgradeMsg = Sql2excelControlPanel::upgradeMessage();
		$this->assignRef('upgradeMsg',$upgradeMsg);

	
		global $mainframe;
		$requestURL	=& JFactory::getURI();
		JHTML::stylesheet( 'sql2excel.css', 'administrator/components/com_sql2excel/assets/' );
		JToolBarHelper::title(   JText::_( 'SQL 2 Excel : Sections' ), 'sql2excelsections' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::help( 'sql2excel_help', true );

		//Filter
		$context 		= 'com_sql2excel.sql2excelsections.list.';

		$filter_state		= $mainframe->getUserStateFromRequest( 
						$context.'filter_state',
						'filter_state', 
						'', 
						'word' );
		$filter_order		= $mainframe->getUserStateFromRequest( 
						$context.'filter_order',
						'filter_order', 
						'','ordering', 
						'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( 
						$context.'filter_order_Dir',
						'filter_order_Dir', 
						'', 
						'word' );
		$search			= $mainframe->getUserStateFromRequest(
						 $context.'search',
						'search', 
						'', 
						'string');

		$search			= JString::strtolower( $search );


		// Get data from the model
		$model	=& $this->getModel();
		$items	= & $this->get( 'Data');
		$total	= & $this->get( 'Total');
		$pagination = & $this->get( 'Pagination' );


		// state filter
		$lists['state']		= JHTML::_('grid.state',  $filter_state );
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] 	= $filter_order;
		// search filter
		$lists['search']	= $search;
		//$ordering = ($lists['order'] == 'ordering');
		$ordering = 'a.ordering';

		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('total',		$total);
		$this->assignRef('pagination',		$pagination);
		//$this->assignRef('ordering', 	$ordering);
		$this->assignRef('ordering', 	$ordering);
		$this->assignRef('request_url',	$requestURL->toString());

		parent::display($tpl);
	}
}