<?php
/*
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 */
 
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

require_once(JPATH_SITE.DS.'components'.DS.'com_sql2excel'.DS.'helpers'.DS.'parms.php');

class Sql2excelViewSqlexcelsettings extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $adminEmail;


		// Get data from the model
		$model	=& $this->getModel();	
		$sql2excel	= & $this->get( 'Data');

		
		$settings = new stdClass();

		JHTML::stylesheet( 'sql2excel.css', 'administrator/components/com_sql2excel/assets/' );
		
		$cmpParms 	= Sql2excelParms::getParms();
		
		// Section List Settings		
		$settings->templatestyle 		= $model->getThemeOpts('templatestyle',Sql2excelParms::get($cmpParms,'templatestyle', 'sql2excel-silver-grad'));
		$settings->show_ptitle 			= JHTML::_('select.booleanlist',  'show_ptitle', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_ptitle', 1) );								
		$settings->show_section_descr 		= JHTML::_('select.booleanlist',  'show_section_descr', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_section_descr', 1) );						
		$settings->show_category_descr 		= JHTML::_('select.booleanlist',  'show_category_descr', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_category_descr', 1) );			
		$settings->display_description 		= $model->getDescriptionOpts('display_description',Sql2excelParms::get($cmpParms,'display_description', '1'));
		$settings->show_number_cat_reports_head = JHTML::_('select.booleanlist',  'show_number_cat_reports_head', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_number_cat_reports_head', 0) );				
		$settings->show_number_reports_in_cat 	= JHTML::_('select.booleanlist',  'show_number_reports_in_cat', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_number_reports_in_cat', 0) );		
		$settings->show_download_button 	= JHTML::_('select.booleanlist',  'show_download_button', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_download_button', 1) );
		$settings->show_preview_button 		= JHTML::_('select.booleanlist',  'show_preview_button', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_preview_button', 1) );
		$settings->preview_mode 		= $model->getPreviewModes('preview_mode',Sql2excelParms::get($cmpParms,'preview_mode', 'popup'));						
		$settings->section_ordering 		= $model->getSectionListOrdering('section_ordering',Sql2excelParms::get($cmpParms,'section_ordering', '1'),false);								
		$settings->category_ordering 		= $model->getSectionListOrdering('category_ordering',Sql2excelParms::get($cmpParms,'category_ordering', '1'),false);						
		$settings->file_ordering 		= $model->getSectionListOrdering('file_ordering',Sql2excelParms::get($cmpParms,'file_ordering', '1'),true);				
		$settings->pagination 			= Sql2excelParms::get($cmpParms,'pagination', '5;10;15;20;50');
		$settings->default_pagination 		= Sql2excelParms::get($cmpParms,'default_pagination', '20');
		
		
		// Worksheet Settings
		$settings->show_sql_errors 		= JHTML::_('select.booleanlist',  'show_sql_errors', 'class="inputbox"', Sql2excelParms::get($cmpParms,'show_sql_errors', 1) );
		$settings->subst_head_footer 		= JHTML::_('select.booleanlist',  'subst_head_footer', 'class="inputbox"', Sql2excelParms::get($cmpParms,'subst_head_footer', 1) );
		$settings->subst_sql 			= JHTML::_('select.booleanlist',  'subst_sql', 'class="inputbox"', Sql2excelParms::get($cmpParms,'subst_sql', 1) );
		$settings->showsqlhelptabs 		= JHTML::_('select.booleanlist',  'showsqlhelptabs', 'class="inputbox"', Sql2excelParms::get($cmpParms,'showsqlhelptabs', 1) );
		$settings->sqlhelplinks			= Sql2excelParms::get($cmpParms,'sqlhelplinks', "&lt;span width=200&gt;&lt;center&gt;&lt;a href=&quot;http://dev.mysql.com/doc/refman/5.0/en/sql-syntax.html&quot; target=&quot;_NEW&quot;&gt;MySQL SQL Syntax&lt;/a&gt;&lt;/center&gt;&lt;/span&gt;&lt;span width=200&gt;&lt;center&gt;&lt;a href=&quot;http://Joomla-R-Us.com/sql2excelsvarref&quot; target=&quot;_NEW&quot;&gt;Variable Substitution Reference&lt;/a&gt;&lt;/center&gt;&lt;/span&gt;&lt;span width=200&gt;&lt;center&gt;&lt;a href=&quot;http://Joomla-R-Us.com/sql2excelformulas&quot; target=&quot;_NEW&quot;&gt;Formulas&lt;/a&gt;&lt;/center&gt;&lt;/span&gt;");
		$settings->livesyntax 			= JHTML::_('select.booleanlist',  'livesyntax', 'class="inputbox"', Sql2excelParms::get($cmpParms,'livesyntax', 1) );
		

		// Security Settings
		$settings->badwordssql 			= JHTML::_('select.booleanlist',  'badwordssql', 'class="inputbox"', Sql2excelParms::get($cmpParms,'badwordssql', 1) );
		$settings->badwords 			= Sql2excelParms::get($cmpParms,'badwords', 'ALTER,CREATE,DELETE,DROP,GRANT,INSERT,KILL,LOAD,LOCK,RENAME,REPLACE,REVOKE,SET,TRUNCATE,UPDATE');
		

		// Excel Writer Settings
		$settings->excelwriter 			= $model->getExcelWriter('excelwriter',Sql2excelParms::get($cmpParms,'excelwriter', 'auto'));


		//Global Preview Settings
		$settings->previewmaxrows 		= Sql2excelParms::get($cmpParms,'previewmaxrows', '10');
		$settings->formulas_in_preview	 	= $model->getFormulasPreview('formulas_in_preview',Sql2excelParms::get($cmpParms,'formulas_in_preview', 'Label'));
		$settings->previewdlbutton 		= JHTML::_('select.booleanlist',  'previewdlbutton', 'class="inputbox"', Sql2excelParms::get($cmpParms,'previewdlbutton', 1) );


		
		$this->assignRef('sql2excel',$sql2excel);


		// Set toolbar items for the page
		$isNew	= ( $sql2excel->id < 1 );
		JToolBarHelper::title(   JText::_( 'SQL 2 Excel Pro : Settings' ), 'sql2excelsettings');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		

		$this->assignRef('settings',$settings);


		parent::display($tpl);
	}
}