<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
 
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once( JPATH_COMPONENT.DS.'helpers'.DS.'excel_writer.php' );

class Sql2excelControllerDownload extends Sql2excelController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	 
	var $_writer_version;
	
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'dl'  , 'download' );
		$this->registerTask( 'download'  , 'download' );
	}

	function download()
	{
		global $mainframe;		
		$id = JRequest::getVar( 'id', 0, 'get', 'int' );
		$wb_id = (int) $id;
							
		$wbParms = $this->getWorkbookParms($wb_id);
		if ( count($wbParms) ) {		
			$cmpParms = &$mainframe->getParams();
			$substParms = $this->getSubstParms();			
			$wsParms = $this->getWorksSheetParms($wb_id);	
			writeExcel::writeFile($wbParms,$wsParms,$cmpParms,$substParms );
		} else {
			JError::raiseError(500, JText::_( 'ERROR : Excel Workbook Not Found!' ) );
		}
		exit;			
	}

	/**
	 * Returns the Workbook Parameters
	 * @return object with parms
	 */
	function getWorkbookParms($id, $preview=0)
	{
		$db	= & JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$aid 		= $user->get('aid', 0);	

		$wheres[] = " a.id = " . (int) $id;	
		$wheres[] = " a.section = b.id ";
		$wheres[] = " a.category = c.id ";
		$wheres[] = " a.published=1 ";
		$wheres[] = " b.published=1 ";
		$wheres[] = " c.published=1 ";

		if ($aid !== null) {
			$wheres[] = "a.access <= " . (int) $aid;
			$wheres[] = "b.access <= " . (int) $aid;
			$wheres[] = "b.access <= " . (int) $aid;
		}

		$query = " SELECT a.* " .
			 " FROM #__sql2excel_workbooks AS a, #__sql2excel_sections AS b, #__sql2excel_categories AS c " .
			 " WHERE " . implode( " AND ", $wheres );

		$db->setQuery( $query );
		$rows = $db->loadObjectList();	
		
		// Update Workbook Download count
		if ( count($rows) >= 1 &&  $preview==0 ) {
			$query = ' UPDATE #__sql2excel_workbooks ' .
			 	 ' SET count=count+1 ' .
			 	 ' WHERE ID=' . (int) $id;
			$db->setQuery( $query );
			$db->query();	
		}

		return $rows;
	}	
	

	/**
	 * Returns worksheet info
	 */
	function getWorksSheetParms($id, $ws_id=0)
	{
		$db	= & JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$aid 		= $user->get('aid', 0);	

		$wheres[] = ' a.id=b.ws_id ';	
		$wheres[] = ' b.wb_id=' .  $id . ' ';	
		if ( $ws_id > 0 ) {
			$wheres[] = ' a.id=' .  $ws_id . ' ';
		}
		
		$wheres[] = " a.published=1 ";
		$wheres[] = " b.wb_id=c.id ";
		$wheres[] = " c.published=1 ";
		$wheres[] = " c.section=d.id ";
		$wheres[] = " c.category=e.id ";
		$wheres[] = " d.published=1 ";
		$wheres[] = " e.published=1 ";

		if ($aid !== null) {
			$wheres[] = "a.access <= " . (int) $aid;
			$wheres[] = "c.access <= " . (int) $aid;
			$wheres[] = "d.access <= " . (int) $aid;
			$wheres[] = "e.access <= " . (int) $aid;
		}

		
		$query = ' SELECT a.id as key1, b.id as key2, a.*, b.* ' .
			 ' FROM #__sql2excel_worksheets AS a, #__sql2excel_worksheet2book AS b,  #__sql2excel_workbooks AS c, #__sql2excel_sections AS d, #__sql2excel_categories AS e' .
			 ' WHERE ' . implode(' AND ', $wheres ) . 
			 ' ORDER BY b.ordering';



		$db->setQuery( $query );
		$rows = $db->loadObjectList();	

		// Update Worksheet Download counts
		if ( count($rows) >= 1 && $ws_id == 0 ) {
			$wsIDs = array();
			foreach ( $rows as $row ) {
				$wsIDs[] = $row->ws_id;				
			}
			$wsIDs = implode(',', $wsIDs);

			$updateSQL = 	' UPDATE #__sql2excel_worksheets c ' .
					' SET c.count=c.count+1 ' .
					' WHERE c.ID IN ( ' . $wsIDs . ')';

			$db->setQuery( $updateSQL );
			$db->query();
		}

		return $rows;	
	}	

	/**
	 * Returns Substitution Parameters
	 * @return array with parms/values
	 */
	function getSubstParms()
	{
		$sparms = array();

		// User Variables
		$user =& JFactory::getUser();	
		$sparms{'USER_ID'} = $user->id;
		$sparms{'USERNAME'} = $user->username;
		$sparms{'USER_NAME'} = $user->name;
		$sparms{'USER_EMAIL'} = $user->email;
		$sparms{'USER_TYPE'} = $user->usertype;
		$sparms{'USER_SEMAIL'} = $user->sendEmail;
		$sparms{'USER_GID'} = $user->gid;
		$sparms{'USER_RDATE'} = $user->registerDate;
		$sparms{'USER_LDATE'} = $user->lastvisitDate;
		$sparms{'USER_ACTIVATION'} = $user->activation;
		$sparms{'USER_AID'} = $user->aid;
		$userParams = $user->params;
		$userParams = explode("\n",$userParams);
		foreach ( $userParams as $p ) {
			$p = explode('=',$p);
			if ( count($p) == 2 && $p[0] == 'timezone' ) {
				$sparms{'USER_TZ'} = $p[1];
			} elseif ( count($p) == 2 && $p[0] == 'language' ) {
				$sparms{'USER_LANG'} = $p[1];
			}
		}
		$sparms{'USER_IP'} = $_SERVER['REMOTE_ADDR'];
		$sparms{'USER_AGENT'} = $_SERVER['HTTP_USER_AGENT'];


		// Server Variables
		$sparms{'SERVER_URL'} = JURI::root();
		$sparms{'SERVER_HOST'} = $_SERVER['HTTP_HOST'];
		$sparms{'SERVER_SERVERIP'} = $_SERVER['SERVER_ADDR'];
		$sparms{'SERVER_SOFTWARE'} = $_SERVER['SERVER_SOFTWARE'];
		if ( isset($_SERVER['HTTP_REFERER']) ) {
			$referer = $_SERVER['HTTP_REFERER'];
			$sparms{'SERVER_REFERER'} = $referer;

			$referer_queryString = parse_url($referer);
			if ( isset($referer_queryString['query']) ) {
				$referer_queryString = $referer_queryString['query'];
				parse_str($referer_queryString, $matches);
				$urlParms = array_keys($matches);
				foreach ( $urlParms as $parmName ) {
					$parmVal = explode(':', $matches{$parmName});
					$sparms{'JOOMLA_PARM_' . strtoupper($parmName) } = $parmVal[0];
				}
			}			
		}

		// Joomla Variables
		$version = new JVersion();
		$sparms{'JOOMLA_VER_LONG'} 	= $version->getLongVersion();
		$sparms{'JOOMLA_VER'} 		= $version->getShortVersion();
		

		// SQL 2 Excel Variables
		$sparms{'SQL2EXCEL_DLURL'} = JURI::root() . substr($_SERVER['REQUEST_URI'],1);

		return $sparms;
	}	
}