<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once( JPATH_COMPONENT.DS.'controllers'.DS.'download.php' );
require_once( JPATH_COMPONENT.DS.'helpers'.DS.'excel_writer.php' );
require_once( JPATH_COMPONENT.DS.'helpers'.DS.'parms.php' );

class Sql2excelControllerPreview extends Sql2excelController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	 
	
	var $_wsArr;
	var $_headArr;	
	var $_formulas;
	
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'ws'  , 'previewWorksheet' );
		$this->registerTask( 'popup'  , 'previewPopup' );
	}


	// Build popup preview page
	function previewPopup()
	{
		global $mainframe;
		$wb_id 	= JRequest::getVar( 'id', 0, 'get', 'int' );
		
		$wbParms = Sql2excelControllerDownload::getWorkbookParms($wb_id,1);

		$cmpparams =& JComponentHelper::getParams( 'com_sql2excel' );

		if ( count($wbParms) ) {
		
			echo "<html>\n";
			echo "<head>\n";
			echo '<base href="' . JURI::base()  ."\" />\n";
			echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />\n";
			echo '<link rel="stylesheet" href="' . JURI::base() . "templates/system/css/system.css\" type=\"text/css\" />\n";		
			echo '<link rel="stylesheet" href="' . JURI::base() . "templates/system/css/general.css\" type=\"text/css\" />\n";		
			$jaCSS = JPATH_SITE.DS.'templates'.DS.'ja_purity'.DS.'css'.DS.'template.css';
			if ( file_exists($jaCSS) ) {
				echo '<link rel="stylesheet" href="' . JURI::base() . "templates/ja_purity/css/template.css\" type=\"text/css\" />\n";		
			} 

			echo '<link rel="stylesheet" href="' . JURI::base() . "components/com_sql2excel/assets/css/preview.css\" type=\"text/css\" />\n";
			echo '<script type="text/javascript" src="' . JURI::base() . "components/com_sql2excel/assets/js/cba.js\"></script>\n";
			echo '<script type="text/javascript" src="' . JURI::base() . "components/com_sql2excel/assets/js/preview.js\"></script>\n";
			echo '</head>';
			echo '<body>';
			
			$wbParms = $wbParms[0];
		
			echo '<h3>' . $wbParms->link_title . '</h3>';
			
			$wsParms = Sql2excelControllerDownload::getWorksSheetParms($wb_id);
			$nrWorksheets = count($wsParms);
			
			echo '<div id="ajaxtabs-container"></div>';
			echo '<table class="ajax-tabs">';
  			echo '<tr class="ajax-tabs-top">';
  			$i=1;
 			
  			foreach ($wsParms as $ws ) {
  				if ( $i == 1 ) {
  					$id = ' id="sheet1" ';
  					$ws1ID = $ws->ws_id;
  				} else {
  					$id='';
  				}
    				echo '<td ' . $id . ' style="" onClick="UpdateTab(this,' . $ws->ws_id . ');" onMouseOver = "selTab(this,1);" onMouseOut  = "selTab(this,0);"><b>&nbsp;' . str_replace(' ', '&nbsp;', $ws->sheetname) . '&nbsp;</b></td> ';		
    				$i++;
    			}
	
    			echo '<td style="width:100%;"></td>';
  			echo '</tr>';
			echo '<tr>';
			$cspan = $nrWorksheets + 1;
    			echo '<td colspan="' . $cspan. '" id="ajax-tabs-content"></td>';
  			echo '</tr>';
			echo '</table>';
			echo "</div>\n";
			echo "<script language=\"Javascript\">\n";
			echo "// data load\n";
			echo "function UpdateTab( tab, request )\n";
			echo "{\n";
 			echo "var id_name  = 'ajax-tabs-content';\n";			
  			echo "var text  = '<img style=\"position:relative;top:3px;\"' + ' src=\"" . JURI::base() . 'components/com_sql2excel/assets/images/loading_01.gif"> ' . JText::_( 'Loading...') . "';\n";
  			echo "var caching  = true;\n";
  			echo "var template  = '%code%';\n";
  			echo "selTab( tab, 2 );\n";
  			echo "cbaUpdateElement(\n";
    			echo "  id_name,\n";
    			echo "'" . JURI::base() . 'index.php?option=com_sql2excel&controller=preview&task=ws&wbid=' . $wb_id . "&id=' + request,\n";
    			echo " text,\n";
    			echo " caching,\n";
    			echo " template);\n";
			echo "}\n";
			echo "var tab1H = document.getElementById('sheet1');\n";
			echo "UpdateTab(tab1H," . $ws1ID . ");\n";
			echo "</script>\n";
			

			// Show Download Button?
			$wbRefresh = '';
			if ( Sql2excelParms::get($cmpparams,'previewdlbutton', 1) == 1 ) {
				$wbRefresh .= "<input type=\"submit\" value=\"&nbsp;&nbsp;" . JText::_( 'Download Spreadsheet') . "&nbsp;&nbsp;\">\n";
			}			
			
			echo "<p>\n";
			echo "<form type=\"get\" action=\"index.php\">\n";
			echo "<center>\n";
			echo  $wbRefresh;
			echo "</center>\n";
			echo "<input type=\"hidden\" name=\"option\" value=\"com_sql2excel\">\n";
			echo "<input type=\"hidden\" name=\"controller\" value=\"download\">\n";
			echo "<input type=\"hidden\" name=\"task\" value=\"dl\">\n";
			echo "<input type=\"hidden\" name=\"id\" value=\"" . $wb_id . "\">\n";
			echo "</form>\n";
			echo "<br>\n";
			echo "</p>\n";
			echo '</body>';
			echo '</html>';			



		} else {
			JError::raiseError( 500, JText::_( 'Workbook not found' ) );	
		}



		exit;
	}
	

	// Return Ajax data for a worksheet
	function previewWorksheet()
	{
		global $mainframe;
		$id 	= JRequest::getVar( 'wbid', 0, 'get', 'int' );
		$wb_id 	= (int) $id;
		$id 	= JRequest::getVar( 'id', 0, 'get', 'int' );
		$ws_id 	= (int) $id;	
		$cbaid 	= JRequest::getVar( '_cba_request_id', 0, 'get', 'int' );
		
		// Workbook Parameters
		$wbParms = Sql2excelControllerDownload::getWorkbookParms($wb_id,1);
		
		if ( count($wbParms) ) {
			$cmpParms = &$mainframe->getParams();
			$substParms = Sql2excelControllerDownload::getSubstParms();			
			$wsParms = Sql2excelControllerDownload::getWorksSheetParms($wb_id, $ws_id);	
			
			if ( count($wsParms) == 1 ) {
				$wsParms = $wsParms[0];
				$wsData = $this->writeWorksheet($wbParms,$wsParms,$cmpParms,$substParms);
				$wsData = str_replace("\r\n",'', $wsData);
				$wsData = str_replace("\n",'', $wsData);
				$wsData = str_replace("\\","\\\\", $wsData);
				$wsData = str_replace('"','\"', $wsData);				
			
				echo '_cba.ready ( ' . (int) $cbaid . ', { "code" : "' . $wsData . '" } );';
			} else {
				echo '_cba.ready ( ' . (int) $cbaid . ', { "code" : "' . JText::_( 'ERROR : Worksheet not found' ) . '" } );';
			}
		
		} else {
			echo '_cba.ready ( ' . (int) $cbaid . ', { "code" : "' . JText::_( 'ERROR : Workbook not found' ) . '" } );';
		
		}
		
		exit;
		
	}
	

	function writeWorksheet($wbParms,$ws,$cmpParms,$substParms)
	{
	
		$output = '';
		
		//$maxRows = $cmpParms->get( 'previewmaxrows', '10' );
		$maxRows = Sql2excelParms::get($cmpParms,'previewmaxrows', '10');
		if ( $ws->preview_rows > 0 ) { $maxRows = $ws->preview_rows; }
		
		//$showFormulas = $cmpParms->get( 'formulas_in_preview', 'Label' );
		$showFormulas = Sql2excelParms::get($cmpParms,'formulas_in_preview', 'Label');
		if ( $ws->preview_formulas != 'Global' ) { $showFormulas = $ws->preview_formulas; }
		
		$formulaLabel = JText::_('#FORMULA');
		
		$this->_formulas = $this->contains_formulas($ws);
		
		$hideColumns = $ws->preview_hidecols;
		$hideColumns = explode(',',trim($hideColumns));
		
		
   		$db	= & JFactory::getDBO();  	
		$wbParms = $wbParms[0];
		$extraParms = array();

      		// Write Header
      		$fileName = $wbParms->filename;
      		if ( trim($fileName) == '' ) {
      			$fileName = 'download.xls';
      		}
      		
      		
		$extraParms['SQL2EXCEL_WB_FN'] = $fileName;
		$extraParms['SQL2EXCEL_WB_LINK'] = $wbParms->link_title;
		$extraParms['SQL2EXCEL_WB_DLCNT'] = $wbParms->count;

		$sheetName = $ws->sheetname;
		if ( trim($sheetName) == '' ) {
			$sheetName = 'Sheet [N]';
		}
		$extraParms['SQL2EXCEL_WS_SN'] = $sheetName;
		$extraParms['SQL2EXCEL_WS_DLCNT'] = $ws->count;

		$query = $ws->query;
		$extraParms['SQL2EXCEL_WS_SQL_RAW'] = $query;

		// Substitute variables in SQL query?
		if ( Sql2excelParms::get($cmpParms,'subst_sql', '1') ) {	
			$query = writeExcel::replace_vars($query, $substParms);
		}
		$extraParms['SQL2EXCEL_WS_SQL'] = $query;

		$formulas = explode(',', $ws->formulas );

		// Get Database Connection
		$db = & JFactory::getDBO();  
		
		// Run query!	
		if ( $db ) {
			$rows = writeExcel::getResults($db, $query, $cmpParms);
		} else {
			$rows = JText::_( 'DB_CONNECT_ERROR');
		}
		
		
		if ( is_array($rows) ) {

			$extraParms['SQL2EXCEL_WS_ROWS'] = count($rows) + 1;


      			// Column titles
			$colNames = writeExcel::getColumnNames($rows);
			//Number of Columns in user query (exclude JoomFish fields if any)
			$nrCols = writeExcel::getColumnCount($colNames, $query);
			
      			// Add Header, if specified
      			$currRow = 0;
      			$header = $ws->header;
      			$headertextArr = explode("\n",$header);
      			$substHeadFoot = Sql2excelParms::get($cmpParms,'subst_head_footer', '1');
      			if ( is_array($headertextArr) ) {
         			foreach ($headertextArr as $headerrow) {
					$headerrow = trim($headerrow);
					if ( $substHeadFoot ) {
						$headerrow = writeExcel::replace_vars($headerrow, $substParms, $extraParms );
					}
               				$output .= $this->writeCell($headerrow, '', $currRow, 0);
            				$currRow++;
        			 }
      			} 
      			$headerRows = $currRow;
      			
      			// Add column titles
      			$actualCol=0;
       			for ($i=0; $i<$nrCols; $i++) 
			{
         			$currCol = $i+1;
         			if ( !in_array($currCol,$hideColumns) &&  (!in_array($currCol,$formulas) || ( in_array($currCol,$formulas) && $showFormulas != 'Hide' )) ) {
					$output .= $this->writeTH($currRow, $actualCol, $colNames[$i]);
					$actualCol++;
				}
			}
			$colHeadRow = $currRow;

      			
      			// Add all the data
      			$currRow++;
      			$cnt=1;
      			$mindatarow = $currRow + 1;
      			$maxdatarow = $currRow + count($rows);      			
      			foreach ( $rows as $row ) {
      				if ( $cnt <= $maxRows ) {
      					$actualCol=0;
         				for ( $i=0; $i<$nrCols; $i++) {
         					
         					$currCol = $i+1;
         					if ( !in_array($currCol,$hideColumns) && (!in_array($currCol,$formulas) || ( in_array($currCol,$formulas) && $showFormulas != 'Hide' )) ) {
							$output .= $this->writeCell($row->$colNames[$i],'',$currRow, $actualCol, $formulas, $showFormulas, $formulaLabel,$mindatarow,$maxdatarow);
							$actualCol++;
						}
						
         				}
        				$currRow++;
        			}
        			$cnt++;
      			}

      			// Add Footer, if specified
      			$footer = $ws->footer;
			$footertextArr = explode("\n",$footer);
			$firstFooterRow = $currRow;
			if ( is_array($footertextArr) ) {
				foreach ($footertextArr as $footerrow) {
					$footerrow = trim($footerrow);	
					if ( $substHeadFoot ) {
						$footerrow = writeExcel::replace_vars($footerrow, $substParms, $extraParms );
					}
			               	$output .= $this->writeCell($footerrow, '', $currRow, 0);
					$currRow++;
				}
     			 }  
     			      			 
     			 // Generate output from the table in memory
     			 $output = $this->formatOutput($maxRows, $colHeadRow, $headerRows, $firstFooterRow, $nrCols);

     			 
     			 // Add truncation / formulas / hidden columns message, if applicable
     			 $notes = '';
     			 if ( count($rows) > $maxRows ) {
     			 	$notes .= '<li>' . JText::_( 'Preview showing ') . $maxRows .  ' ' . JText::_( 'of') . ' ' . count($rows) .  ' ' .  JText::_( 'records') . '</li>';
     			 }
     			 if ( $this->_formulas && ( $showFormulas == 'Show' || $showFormulas == 'Label') ) {
     			 	$notes .= '<li>' . JText::_('FORMULAS_NOT_IN_PREVIEW') . '.</li>';
     			 }
     			 if ( $this->_formulas && $showFormulas == 'Hide' ) {
     			 	$notes .= '<li>' . JText::_('FORMULAS_HIDDEN_IN_PREVIEW') . '.</li>';
     			 }
     			 if ( count($hideColumns) > 1 || $hideColumns[0] > 0 ) {
     				 $notes .= '<li>' . JText::_('COLUMNS_HIDDEN_IN_PREVIEW') . '.</li>';
     			 }
     			 if ( $notes != '' ) {
     			 	$output .= '<p><br><b>Notes:</b><ul>' . $notes . '</ul></p><p>' . JText::_( 'PLEASE_DL_FULL_REPORT')  . '</p>';
     			 }


      		} elseif ( $rows == '' ) {
      			// Empty recordset.       			
      			$output .= '<tr><td>' . JText::_( 'No records found' ) . '</td></tr>'; 
      			$output .= $this->tableEnd(); 
      		} elseif ( $rows != '' && is_string($rows) && Sql2excelParms::get($cmpParms,'show_sql_errors', 1)  ) {
      			$errMsg = explode("\n", $rows);
      			foreach ( $errMsg as $row ) {
      				$output .= $this->newRow();
				$row = trim($row);
				$output .= $this->writeCell($row);
				$output .= $this->endRow();      				
      			}
      			$output .= $this->tableEnd(); 
      		}
      		     		
		
		return $output;
	}
	

	function newRow($extra='')
	{
		return '<tr' . $extra . '>';
	}

	function endRow()
	{
		return '</tr>';
	}

	function tableEnd()
	{
		$retStr = '</table>';
		return $retStr;
	}
	
	function writeCell($str, $extra='', $row=0, $col=0, $formulas=0, $showFormulas='Label', $formulaLabel='#FORMULA',$mindatarow=0,$maxdatarow=0)
	{
		if ( substr(strtolower($str),0,7) == 'http://' ) {
			$str = '<a href="' . $str . '" target="_NEW">' . $str . '</a>';
		} elseif ( substr(trim($str),0,1) == '=' || substr(trim($str),0,1) == '@' ) {
			$colUser = $col+1;
			$rowUser = $row+1;
			if ( is_array($formulas) & in_array($colUser, $formulas) ) {			
				// Formula!
				$this->_formulas = true;

				if ( $showFormulas == 'Label' ) {
					// Show Generic #FORMULA Label
					$str = $formulaLabel;
				} elseif ( $showFormulas == 'Show' ) {
					// Show Full Formula Syntax
					// Parse and replace Row and Col ID's
					$str = writeExcel::replace_row_col_ids($str, $rowUser, $colUser,$mindatarow,$maxdatarow);
				} else {
					// Hide Formula
					return;
				}
			}
		}		
		if ( $str == '' ) { $str='&nbsp;'; }
		
		// Add cell to array		
		if ( isset($this->_wsArr[$row]) ) {
			$currRowArr = $this->_wsArr[$row];
		} else {
			$currRowArr = array();
		}
		$currRowArr[$col] = $str;
		$this->_wsArr[$row] = $currRowArr;
		
	}

	function writeTH($row, $col, $str, $extra='')
	{
	
		// Add cell to array		
		if ( isset($this->_wsArr[$row]) ) {
			$currRowArr = $this->_wsArr[$row];
		} else {
			$currRowArr = array();
		}
		$currRowArr[$col] = $str;
		$this->_wsArr[$row] = $currRowArr;
		
	}

	
	function formatOutput($maxRows, $colHeadRow, $headerRows, $firstFooterRow, $nrDataCols)
	{

		// Get max row number
		$rowMax = max(array_keys($this->_wsArr));

		// Get max column number
		$maxCol = 0;
		foreach ( $this->_wsArr as $row ) {		
			$col = max(array_keys($row));
			if ( $col > $maxCol ) { $maxCol = $col; }
		}

		// Max Data Column Number
		$nrDataCols--;
		
		
		$retStr = '<table class="datatable" cellspacing=0>';	
		
		$colSpan = $maxCol+1;
		// Add rows		
		for ( $idx=0; $idx<=$rowMax; $idx++ ) {
			if ( isset($this->_wsArr[$idx]) ) {
				$row = $this->_wsArr[$idx];
			} else {
				$row = array();
			}			
			$retStr .= '<tr>';
			
			$maxRowCol = max(array_keys($row));
			//$retStr .= '<td>'. $maxRowCol . '</td>';
			
			
			for ( $i=0; $i<=$maxRowCol; $i++ ) {
				if ( isset($row[$i]) ) {
					$str = $row[$i];
				} else {
					$str='&nbsp;';
				}
				if ( $idx == $colHeadRow ) {
					// Data Column Header
					
					// First Column?
					$extra = '';
					if ( $i == 0 ) { $extra .= 'border-left: 1px solid #000;'; }					
					$extra = ' style="' . $extra . '"';
					
					if ( $str != '' ) {
						$retStr .= '<th' . $extra . '>'. $str . '</th>';
					} else {
						$retStr .= '<td>&nbsp;</td>';
					}
					
					if ( $i == $maxRowCol && $maxCol > $i ) {
						$rcSpan = $colSpan - $i;
					   	$retStr .= '<td colspan="' . $rcSpan . '">&nbsp;</td>';
					}
					
				} else if ( ($idx < $headerRows || $idx >= $firstFooterRow) && $i == $maxRowCol ) {					
					$rcSpan = $colSpan - $i;
					if ( $rcSpan > 1 ) {
						$retStr .= '<td colspan="' . $rcSpan . '" align="left">' . $str . '</td>';
					} else {

						$retStr .= '<td align="left">'. $str . '</td>';
					}
				} else {
					// Data Rows  or  Multiple Cell Header / Footer Rows
					$extra = '';
					
					// First Column and inside Data?
					if ( $i == 0 && $idx > $headerRows && $idx < $firstFooterRow ) { $extra .= 'border-left: 1px solid #000;'; }
					
					// Last Column?
					if ( $i == $nrDataCols ) { $extra .= 'border-right: 1px solid #000;'; }
					
					
					// Last Data Row?					
					if ( $idx == $firstFooterRow - 1 ) {
						$extra .= 'border-bottom: 1px solid #000;';
					}
					
					$extra = ' style="' . $extra . '"';
					
					$retStr .= '<td align="left"' . $extra .'>'. $str . '</td>';
					if ( $i == $maxRowCol && $i < $maxCol ) {
						$rcSpan = $colSpan - $i;					
						$retStr .= '<td colspan="' . $rcSpan . '">&nbsp;</td>';
					}
				}				
			}
			
			$retStr .= '</tr>';
		}
		$retStr .= '</table>';
		
		return $retStr;

	}
	

	function contains_formulas($ws) {
	
		if ( $ws->formulas != '' ) {
			return true;
		} else {
      			return false;
		}
	}
}