<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component SQL 2 Excel Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

/**
* Method to build Route
* @param array $segments
*/ 
function Sql2excelBuildRoute(&$query)
{
   $segments = array();
   
   if( isset($query['view']) )
   {
      $segments[0] = $query['view'];
      unset( $query['view'] );
      
      $segments[1] = $query['id'];
      unset( $query['id'] );
   } 
   elseif (isset($query['controller'])  )
   {
      $segments[0] = $query['controller'];
      unset( $query['controller'] );
      $segments[1] = $query['task'];
      unset( $query['task'] );
      $segments[2] = $query['id'];
      unset( $query['id'] );
   };
 
   return $segments;
}


/**
* Method to parse Route
* @param array $segments
*/
function Sql2excelParseRoute($segments)
{

   $vars = array();
   
   // Get the active menu item.
   $menu   = &JSite::getMenu();
   $item   = &$menu->getActive();

   // Count segments
   $count = count( $segments );

   if (isset($segments[0]) && $segments[0] == 'pre')
   {
      $vars['view']   = 'pre';
      $vars['id']      = $segments[1];
   }
   elseif (isset($segments[0]) && ($segments[0] == 'preview' || $segments[0] == 'download'))
   {
      $vars['controller']   = $segments[0];
      $vars['task']   = $segments[1];
      $vars['id']   = $segments[2];
   }
   else
   {      
      // Count route segments
      $count = count($segments);
   
      // Check if there are any route segments to handle.
      if ($count)
      {
         //if ($count == 2)
         //{
            // DEBUG FOR NOW!
            $vars['view']   = $segments[0];
            $vars['id']      = $segments[$count-1];
         //}
      }
   }

  
  return $vars;
  
}
?>