<?php
/*
 * @component SQL 2 Excel Pro Component
 * @copyright Copyright (C) Joomla-R-Us, joomla-r-us.com
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 *
 * Original code by Jan Pavelka (www.phoca.cz) 
 * Adapted by Joomla-R-Us for SQl 2 Excel Pro
 *
 */

/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component Phoca Component
 * @copyright Copyright (C) Jan Pavelka www.phoca.cz
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */ 

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');
require_once( JPATH_COMPONENT.DS.'helpers'.DS.'parms.php' );

class Sql2excelViewCategory extends JView
{

	function display($tpl = null)
	{		
		$params 			= Sql2excelParms::getParms();	
		$uri 				= &JFactory::getURI();
		$model				= &$this->getModel();
		$document			= &JFactory::getDocument();
		$categoryId			= JRequest::getVar('id', 0, '', 'int');
		$limitStart			= JRequest::getVar( 'limitstart', 0, '', 'int');
		$section			= $model->getSection($categoryId, $params);
		$category			= $model->getCategory($categoryId, $params);
		$workbooks			= $model->getDocumentList($categoryId, $params);
		
		$keywords			= $model->getDocumentKeywords($workbooks);
		$document->setMetadata('Keywords', $keywords);
		

		$previewButton 		= Sql2excelParms::get($params,'show_preview_button', '1');		
		$downloadButton 	= Sql2excelParms::get($params,'show_download_button', '1');	
		$showCatDescr		= Sql2excelParms::get($params,'show_category_descr', '1');
		$showPageTitle		= Sql2excelParms::get($params,'show_ptitle', '1');
		

		$tmpl			= array();
		$tmpl['pagination']	= $model->getPagination($categoryId, $params);
		
		// Limit start
		if ($limitStart > 0 ) {
			$tmpl['limitstarturl'] =  '&start='.$limitStart;
		} else {
			$tmpl['limitstarturl'] = '';
		}
		
		// Template Style
		$style	= $params->get( 'templatestyle', 'sql2excel-tealblue' );		
		$document->addStyleSheet(JURI::base(true).'/components/com_sql2excel/assets/css/'.$style.'.css');
		

		// PARAMS
		$paramsTmpl['download_external_link']	= Sql2excelParms::get($params,'download_external_link', '_self');
		$paramsTmpl['filename_or_name']		= Sql2excelParms::get($params,'filename_or_name', 'filename');
		$paramsTmpl['display_downloads']	= Sql2excelParms::get($params,'display_downloads', 0);		
		$paramsTmpl['display_detail'] 		= Sql2excelParms::get($params,'display_detail', 1);
		$paramsTmpl['display_description'] 	= Sql2excelParms::get($params,'display_description', 1);
				
		$tmpl['displaynew']			= Sql2excelParms::get($params,'display_new', 0);		
		$tmpl['displayhot']			= Sql2excelParms::get($params,'display_hot', 0);



		// Define image tag attributes
		if (!empty($category[0]->image)) {
			$attribs['align'] = '"'.$category[0]->image_position.'"';
			$attribs['hspace'] = '"6"';

			// Use the static HTML library to build the image tag
			$tmpl['image'] = JHTML::_('image', 'images/stories/'.$category[0]->image, JText::_('Phoca Download'), $attribs);
		} else {
			$tmpl['image'] = '';
		}


		$this->assignRef('tmpl',			$tmpl);
		$this->assignRef('section',			$section);
		$this->assignRef('category',			$category);
		$this->assignRef('show_page_title',		$showPageTitle);
		$this->assignRef('show_cat_descr',		$showCatDescr);
		$this->assignRef('workbooks',			$workbooks);
		$this->assignRef('previewButton',		$previewButton);
		$this->assignRef('downloadButton',		$downloadButton);
		$this->assignRef('params',			$params);
		$this->assignRef('ol',				$ol);
		$this->assignRef('paramstmpl',		$paramsTmpl);
		$this->assignRef('request_url',		$uri->toString());
		parent::display($tpl);
		
	}
}
?>