<?php
/**
 * This file contains the AdminWeatherConfiguration class, which
 *  abstracts the configuration parameters for the eWeather component.
 *
 * This file is part of eWeather.
 *
 *   eWeather is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   eWeather is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with eWeather.  If not, see <a href="http://www.gnu.org/licenses/">
 *   http://www.gnu.org/licenses/</a>.
 *
 * <b>Modifications:</b><br/>
 * aangepast door Mart Dirks<br/>
 * converted to Joomla! 1.5.x by Bob Lavey
 *
 * @version $Id$
 * @package eWeather
 * @subpackage Admin eWeather
 * @copyright Copyright (c) 2000 - 2006 MamboBaer.de (Harald Baer),
 * 			  2007 Mart Dirks,<br/>
 *            2009 Bob Lavey<br/>
 * @license http://www.gnu.org/licenses/gpl.txt GNU/GPL
 * @toto Break this into additional classes: AdminWeatherConfigurationForm,
 *        AdminWeatherInstalledlocationForm, and AdminWeatherInfoForm.
 */

/* ensure this file is being called by Joomla! */
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

require_once(JPATH_ADMINISTRATOR.DS."components/com_eweather/eweather.config.php");

/** @todo finish documentation */
class AdminWeatherConfiguration extends WeatherConfiguration
{
	/** @todo finish documentation */
	function AdminWeatherConfiguration()
	{
		parent::WeatherConfiguration();
	}

	/** @todo finish documentation */
	function WriteToConfigFile()
	{
		clearstatcache();
		@chmod ($this->configFileName_, 0777);
		clearstatcache();
		
		$configtxt = "<?php\r\n"
            ."  \$weatherVersion = \"1.3.12\";\r\n"
            ."  \$weatherPartnerID = \"".$this->partnerID_."\";\r\n"
            ."  \$weatherPassword = \"".$this->partnerKey_."\";\r\n"
            ."  \$weatherDefaultLocationID = \"".$this->defaultLocation_."\";\r\n"
            ."  \$weatherCacheTime = \"".$this->GetCacheTimeAsInt()."\";\r\n"
            ."  \$weatherUnits = \"".$this->units_."\";\r\n"
            ."  \$weatherDayForecast = \"".$this->forecastDays_."\";\r\n"
            ."  \$weatherForecastDaysPerRow = \"".$this->forecastDaysPerRow_."\";\r\n"
            ."  \$weatherHeaderPosition = \"".$this->headerPosition_."\";\r\n"
            ."  \$weatherShowFooter = \"".$this->showFooter_."\";\r\n"
            ."  \$weatherIconsStyle = \"".$this->iconsStyle_."\";\r\n"
            ."  \$weatherShowForecast = \"".$this->showForecast_."\";\r\n"
            ."  \$weatherTimeFormat = \"".$this->timeFormat_."\";\r\n"
            ."  \$weatherLongDateFormat = \"".$this->dateFormatLong_."\";\r\n"
            ."  \$weatherShortDateFormat = \"".$this->dateFormatShort_."\";\r\n"
            ."  \$weatherDetailDateFormat = \"".$this->dateFormatDetail_."\";\r\n"
            ."  \$weatherUseProxy = \"".$this->useProxy_."\";\r\n"
            ."  \$weatherProxyHost = \"".$this->proxyHost_."\";\r\n"
            ."  \$weatherProxyPort = \"".$this->proxyPort_."\";\r\n"
            ."  \$weatherUseProxyAuth = \"".$this->useProxyAuth_."\";\r\n"
            ."  \$weatherProxyAuthUser = \"".$this->proxyAuthUser_."\";\r\n"
            ."  \$weatherProxyAuthPwd = \"".$this->proxyAuthPwd_."\";\r\n"
            ."?>\r\n";

		if ($fp = fopen("$this->configFileName_", "w+"))
		{
			fputs($fp, $configtxt, strlen($configtxt));
			fclose ($fp);
		}
	}
	
	/** @todo finish documentation */
	function ReadFromPost()
	{
		$this->partnerID_          = JRequest::getVar( 'partner_ID', '', 'post' );
		$this->partnerKey_         = JRequest::getVar( 'partner_key', '', 'post' );
		$this->defaultLocation_    = JRequest::getVar( 'default_location', '', 'post');
		$this->cacheTime_          = JRequest::getVar( 'cache_time', '', 'post' );
		$this->units_              = JRequest::getVar( 'weather_units', '', 'post');
		$this->iconsStyle_         = JRequest::getVar( 'icon_style', '', 'post' );
		$this->forecastDays_       = JRequest::getVar( 'forecast_days', '', 'post' );
		$this->forecastDaysPerRow_ = JRequest::getVar( 'forecast_days_per_row', '', 'post' );
		$this->headerPosition_     = JRequest::getVar( 'header_position', '', 'post' );
		$this->showFooter_         = JRequest::getVar( 'show_footer', '', 'post' );
		$this->showForecast_       = JRequest::getVar( 'show_forecast', '', 'post' );
		$this->timeFormat_         = JRequest::getVar( 'time_format', '', 'post' );
		$this->dateFormatLong_     = JRequest::getVar( 'date_format_long', '', 'post' );
		$this->dateFormatShort_    = JRequest::getVar( 'date_format_short', '', 'post' );
		$this->dateFormatDetail_   = JRequest::getVar( 'date_format_detail', '', 'post' );
		$this->useProxy_           = JRequest::getVar( 'use_proxy', '', 'post' );
		$this->proxyHost_          = JRequest::getVar( 'proxy_host', '', 'post' );
		$this->proxyPort_          = JRequest::getVar( 'proxy_port', '', 'post' );
		$this->useProxyAuth_       = JRequest::getVar( 'use_proxy_auth', '', 'post' );
		$this->proxyAuthUser_      = JRequest::getVar( 'proxy_auth_user', '', 'post' );
		$this->proxyAuthPwd_       = JRequest::getVar( 'proxy_auth_pwd', '', 'post' );		
	}
	
	/** @todo finish documentation */
	function Reconcile($params)
	{
		if ($this->partnerID_ == "")
		{
			$this->partnerID_ = $params->partnerID_;
		}
		if ($this->partnerKey_ == "")
		{
			$this->partnerKey_ = $params->partnerKey_;
		}
		if ($this->defaultLocation_ == "")
		{
			$this->defaultLocation_ = $params->defaultLocation_;
		}
		if ($this->cacheTime_ == "")
		{
			$this->cacheTime_ = $params->cacheTime_;
		}
		if ($this->units_ == "")
		{
			$this->units_ = $params->units_;
		}
		if ($this->iconsStyle_ == "")
		{
			$this->iconsStyle_ = $params->iconsStyle_;
		}
		if ($this->forecastDays_ == "")
		{
			$this->forecastDays_ = $params->forecastDays_;
		}
		if ($this->forecastDaysPerRow_ == "")
		{
			$this->forecastDaysPerRow_ = $params->forecastDaysPerRow_;
		}
		if ($this->headerPosition_ == "")
		{
			$this->headerPosition_ = $params->headerPosition_;
		}
		if ($this->showFooter_ == "")
		{
			$this->showFooter_ = $params->showFooter_;
		}
		if ($this->showForecast_ == "")
		{
			$this->showForecast_ = $params->showForecast_;
		}
		if ($this->timeFormat_ == "")
		{
			$this->timeFormat_ = $params->timeFormat_;
		}
		if ($this->dateFormatLong_ == "")
		{
			$this->dateFormatLong_ = $params->dateFormatLong_;
		}
		if ($this->dateFormatShort_ == "")
		{
			$this->dateFormatShort_ = $params->dateFormatShort_;
		}
		if ($this->dateFormatDetail_ == "")
		{
			$this->dateFormatDetail_ = $params->dateFormatDetail_;
		}
		if ($this->useProxy_ == "")
		{
			$this->useProxy_ = $params->useProxy_;
		}
		if ($this->proxyHost_ == "")
		{
			$this->proxyHost_ = $params->proxyHost_;
		}
		if ($this->proxyPort_ == "")
		{
			$this->proxyPort_ = $params->proxyPort_;
		}
		if ($this->useProxyAuth_ == "")
		{
			$this->useProxyAuth_ = $params->useProxyAuth_;
		}
		if ($this->proxyAuthUser_ == "")
		{
			$this->proxyAuthUser_ = $params->proxyAuthUser_;
		}
		if ($this->proxyAuthPwd_ == "")
		{
			$this->proxyAuthPwd_ = $params->proxyAuthPwd_;
		}
	}
}
?>