<?php
/**
 * Sourcerer popup page
 * Selfcontained page that displays a field to paste code in.
 * On insert, the code gets converted to html with some options
 *
 * @package    Sourcerer
 * @version    2.0.1
 * @since      File available since Release 2.0.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/sourcerer
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// This is a selfcontained page
define( '_JEXEC', 1 );

// Include first popup page
include( 'popuppage_start.php' );

// Content

// Include the syndicate functions only once
jimport( 'joomla.plugin.plugin' );
JHTML::_('behavior.tooltip');
require_once( dirname( __FILE__ ).DS.'..'.DS.'..'.DS.'..'.DS.'system'.DS.'sourcerer.php' );

$_db =& JFactory::getDBO();
$_query = "
	SELECT params
	FROM #__plugins
	WHERE folder = 'system'
	AND element = 'sourcerer'
	LIMIT 1";
$_db->setQuery( $_query );
$_plugin_params = $_db->loadResult();
$_plugin_params = new JParameter( $_plugin_params );
$_plugin_params = plgSystemSourcerer::returnParams( $_plugin_params );

$_params = getPluginParams( 'editors-xtd', 'sourcerer', dirname( __FILE__ ).DS.'..'.DS.'..'.DS.'sourcerer.xml' );

$_default_addtags = $_params->get( 'default_addtags', 1 );
$_default_converttags = $_params->get( 'default_converttags', 1 );
$_default_colorizetags = $_params->get( 'default_colorizetags', 1 );
$_default_color_html = $_params->get( 'color_html', '#333366' );
$_default_color_comments = $_params->get( 'color_comments', '#999999' );
$_default_color_css = $_params->get( 'color_css', '#CC0000' );
$_default_color_js = $_params->get( 'color_js', '#0000FF' );
$_default_color_php = $_params->get( 'color_php', '#009900' );

// Load plugin language
$lang =& JFactory::getLanguage();
$lang->load( 'plg_editors-xtd_sourcerer', JPATH_ADMINISTRATOR );

// Add scripts and styles
$_document = & JFactory::getDocument();
$_document->addScript( JURI::root( true ).'/plugins/editors-xtd/sourcerer/js/sourcerer.js' );
$_script = "
	var sourcerer_syntax_start = '".$_plugin_params['syntax_start']."';
	var sourcerer_syntax_start_0 = '".$_plugin_params['syntax_start_0']."';
	var sourcerer_syntax_end = '".$_plugin_params['syntax_end']."';
	var sourcerer_editorname = '".JRequest::getCmd( 'name', 'text' )."';
	var sourcerer_color_html = '".$_default_color_html."';
	var sourcerer_color_comments = '".$_default_color_comments."';
	var sourcerer_color_css = '".$_default_color_css."';
	var sourcerer_color_js = '".$_default_color_js."';
	var sourcerer_color_php = '".$_default_color_php."';
	window.addEvent( 'domready', function() {
		sourcerer_initSource();
		sourcerer_toggleTags( 0, ".$_default_addtags." );
		sourcerer_toggleTagStyle( 0, ".$_default_converttags." );
		sourcerer_toggleColorize();
	} );
";
$_document->addScriptDeclaration( $_script );
$_document->addStyleSheet( JURI::root( true ).'/plugins/editors-xtd/sourcerer/css/sourcerer_popup.css' );

$_isadmin = JRequest::getCmd( 'isadmin', 0 );

$_code = '';
if( $_params->get( 'use_example_code' ) == 1 || ( $_isadmin && $_params->get( 'use_example_code' ) == 2 ) ) {
	$_code = $_params->get( 'example_code' );
}
$_code = str_replace( '<br />', "\n", $_code );
$_code = htmlspecialchars( html_entity_decode( $_code, ENT_QUOTES, 'UTF-8' ), ENT_QUOTES, 'UTF-8' );
$_code = str_replace( '  ', '&nbsp;&nbsp;', $_code );
?>
<form action="index.php" id="sourceForm" method="post">
	<input type="hidden" name="source" value="<?php echo $_code ?>" />
	<input type="hidden" name="colorizetags" value="<?php echo $_default_colorizetags; ?>" />
	<fieldset>
		<div style="float: left">
			<h1><?php echo JText::_( 'Sourcerer Code Helper' ); ?></h1>
		</div>
		<div style="float: right; text-align: right;">
			<div class="button2-left"><div class="blank">
				<a rel="" onclick="sourcerer_convertText();window.parent.document.getElementById('sbox-window').close();" href="javascript://" title="<?php echo JText::_('Insert') ?>"><?php echo JText::_('Insert') ?></a>
			</div></div>
			<div class="button2-left"><div class="blank">
				<a rel="" onclick="window.parent.document.getElementById('sbox-window').close();" href="javascript://" title="<?php echo JText::_('Cancel') ?>"><?php echo JText::_('Cancel') ?></a>
			</div></div>
		</div>
	</fieldset>
 	<p><?php echo JText::_( 'Textarea (description)' ); ?></p>
	<div class="source_div" id="source_div"><?php echo $_code ?></div>
	<fieldset>
		<div style="float: left">
			<div class="button2-left"><div class="tags" id="tags_button">
				<label class="hasTip" title="<?php echo JText::_( 'Toggle {source} tags' ).'::'.JText::_( 'Toggle {source} tags (description)' ); ?>">
					<a rel="" onclick="sourcerer_toggleTags(1);return false;" href="javascript://;"><?php echo JText::_('Toggle {source} tags') ?></a>
				</label>
			</div></div>
			<div class="button2-left"><div class="brackets" id="tagstyle_button">
				<label class="hasTip" title="<?php echo JText::_( 'Toggle tag style' ).'::'.JText::_( 'Toggle tag style (description)' ); ?>">
					<a rel="" onclick="sourcerer_toggleTagStyle(1);return false;" href="javascript://;"><?php echo JText::_('Toggle tag style') ?></a>
				</label>
			</div></div>
			<div class="button2-left"><div class="colorize" id="colorize_button">
				<label class="hasTip" title="<?php echo JText::_( 'Colorize tags' ).'::'.JText::_( 'Colorize tags (description)' ); ?>">
					<a rel="" onclick="sourcerer_toggleColorize(1);return false;" href="javascript://;"><?php echo JText::_('Colorize tags') ?></a>
				</label>
			</div></div>
		</div>
		<div style="float: right; text-align: right;">
			<div class="button2-left"><div class="blank">
				<a rel="" onclick="sourcerer_convertText();window.parent.document.getElementById('sbox-window').close();" href="javascript://" title="<?php echo JText::_('Insert') ?>"><?php echo JText::_('Insert') ?></a>
			</div></div>
			<div class="button2-left"><div class="blank">
				<a rel="" onclick="window.parent.document.getElementById('sbox-window').close();" href="javascript://" title="<?php echo JText::_('Cancel') ?>"><?php echo JText::_('Cancel') ?></a>
			</div></div>
		</div>
	</fieldset>
<?php if( $_isadmin ) { ?>
	<em><?php echo JText::_( 'See the plugin for settings' ); ?> (<a href="<?php echo JURI::base(); ?>administrator/index.php?option=com_plugins&search=sourcerer&filter_type=editors-xtd" target="_blank">Editor Button - Sourcerer</a>)</em>
<?php } ?>
</form>

<?php
// Include second file to output page
include( 'popuppage_end.php' );

function getPluginParams( $type, $plugin, $xml = '' ) {
$_document = & JFactory::getDocument();
	$_params = JPluginHelper::getPlugin( $type, $plugin );
	$_params = new JParameter( $_params->params );		
	if ( $xml && isset( $_params->_registry ) && isset( $_params->_registry['_default'] ) && isset( $_params->_registry['_default']['data'] ) ) {
		$_params->loadSetupFile( $xml );
		foreach( $_params->_xml['_default']->children() as $_xml_param ) {
			$_key = $_xml_param->_attributes['name'];
			$_val = $_xml_param->_attributes['default'];
			if ( $_key[0] != '@' && !isset( $_params->_registry['_default']['data']->$_key ) && isset( $_val ) ) {
				$_params->_registry['_default']['data']->$_key =  $_val;
			}
		}
	}
	return $_params;
}