<?php
/**
 * Main Plugin File
 * Does all the magic!
 *
 * @package    Sourcerer
 * @version    2.0.1
 * @since      File available since Release 1.0.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/sourcerer
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport( 'joomla.event.plugin' );

// Include the syndicate functions only once
if ( is_file( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'sourcerer.php' ) ) {
	require_once ( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'sourcerer.php' );
}

/**
* Button Plugin that places a Sourcerer code block into the text
*/
class plgButtonSourcerer extends JPlugin
{
	/**
	* Constructor
	*
	* For php4 compatability we must not use the __constructor as a constructor for
	* plugins because func_get_args ( void ) returns a copy of all passed arguments
	* NOT references. This causes problems with cross-referencing necessary for the
	* observer design pattern.
	*/
	function plgButtonSourcerer( &$subject, $config )
	{
		if ( !is_file( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'sourcerer.php' ) ) {
			return;
		}

		parent::__construct( $subject, $config );

		// Load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin( 'editors-xtd', 'sourcerer' );
		$this->_params = new JParameter( $this->_plugin->params );
	}

	/**
	* Display the button
	*
	* @return array A two element array of ( imageName, textToInsert )
	*/
	function onDisplay( $name )
	{
		$button = new JObject();

		if ( !is_file( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'sourcerer.php' ) ) {
			return $button;
		}

		global $mainframe;

		$_document =& JFactory::getDocument();

		$_enable_frontend = $this->_params->get( 'enable_frontend' );

		if ( !$mainframe->isAdmin() && !$_enable_frontend ) {
			return $button;
		}

		JHTML::_( 'behavior.modal' );
		$_document->addStyleSheet( JURI::root( true ).'/plugins/editors-xtd/sourcerer/css/sourcerer.css' );

		$_link = 'plugins/editors-xtd/sourcerer/elements/sourcerer.page.php?name='.$name;
		if ( $mainframe->isAdmin() ) {
			$_link = '../'.$_link;
		}

		$button->set( 'modal', true );
		$button->set( 'link', $_link );
		$button->set( 'text', JText::_( 'Sourcerer' ) );
		$button->set( 'name', 'sourcerer' );
		$button->set( 'options', "{handler: 'iframe', size: {x: 700, y: 420}}" );

		return $button;
	}

}