<?php
/**
 * Element: Dependency
 * Displays an error if given file is not found
 *
 * @package    NoNumber! Elements
 * @version    v1.0.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Dependency Element
 *
 * Available extra parameters:
 * label	The name of the extension that is needed
 * file		The file to check (from the root)
 */
class JElementDependency extends JElement
{
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$_name = 'Title';

	function fetchTooltip( $label, $description, &$node, $control_name, $name )
	{
		return;
	}

	function fetchElement( $name, $value, &$node, $control_name )
	{
		global $mainframe;

		$_label		= $this->def( $node->attributes( 'label' ), 'the main extension' );
		$_file		= $node->attributes( 'file' );
		$_file = str_replace( '/', DS, $_file );

		if ( file_exists( JPATH_ROOT.DS.$_file ) ) {
			return;
		}

		$_msg = JText::sprintf( 'This extension needs the main extension to function', $_label );
		$_message_set = 0;
		$messageQueue = $mainframe->getMessageQueue();
		foreach ( $messageQueue as $_queue_message ) {
			if ( $_queue_message['type'] == 'error' && $_queue_message['message'] == $_msg ) {
				$_message_set = 1;
				break;
			}
		}
		if ( !$_message_set ) {
			$mainframe->enqueueMessage( $_msg, 'notice' );
		}
		return;
	}

	function def( $val, $default )
	{
		return ( $val == '' ) ? $default : $val;
	}
}