<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Joomla! JRPassphrase
 * Version 1.54  , May 14th, 2009
 * @author		Roger Noar
 * @package		Joomla 1.50
 * @subpackage	System
 */
class  plgSystemJRPassphrase extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemJRPassphrase(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterDispatch()  // Don't use onAfterInitialize - not reliable for redirection if SEF's are used
	{
		global $mainframe;
		$option	= JRequest::getCmd('option');
		$task	= JRequest::getCmd('task');
		$view	= JRequest::getCmd('view');
		$pass 	= '';
		$pass	= JRequest::getCmd('pass');

		if ( $task != 'register' && $view != 'register' ) { Return ;} //Exit if not a registration page - low overhead

//  Get current URL
		$uri =& JFactory::getURI();
		$url = $uri->toString();
		$u_host = $uri->getHost();
		$u_path = $uri->getPath();		

//  Get parameters	
		$debug = $this->params->get('debug', '');		
		$reg_pass = $this->params->get('reg_passphrase', '');
		$reg_path = ('http://'. $u_host . '/plugins/system/JRPassphrase_reg.php');
		$alt_reg_url = $this->params->get('alt_reg_url', '');
		$passphrase_page_url = $this->params->get('passphrase_page_url', '');
		$use_module = $this->params->get('use_module', '');
		$fail_message = $this->params->get('fail_message', '');
		$intercept_message = $this->params->get('intercept_message', '');
		
		if ( $use_module =='1') { $reg_path = '/index.php' ;} //reg path is front page if using module		
		if ( !empty($passphrase_page_url) ) { $reg_path = $passphrase_page_url ;} //alternate location for passphrase page

//	Remove carriage returns	& spaces from the passphrase 
		$syms= array(" ","\r\n","\n\r","\r","\n","\l","\t",chr(13),chr(10)); //remove carriage returns & spaces
		$reg_pass= str_replace($syms, '', $reg_pass);
		$pass= str_replace($syms, '', $pass);
		$reg_pass=trim(strtolower($reg_pass)); //lower case only, remove leading & trailing spaces
		$pass=trim(strtolower($pass)); //lower case only, remove leading & trailing spaces

//  Display debug info
		if ($debug=='1') 
		{ 
		$mainframe->enqueueMessage( 'use_module=' . $use_module ) ;					
		$mainframe->enqueueMessage( 'pass=' . $pass ) ;				
		$mainframe->enqueueMessage( 'reg_pass=' . $reg_pass ) ;				
		$mainframe->enqueueMessage( 'alt_reg_url=' . $alt_reg_url ) ;			
		$mainframe->enqueueMessage( '$passphrase_page_url=' . $passphrase_page_url ) ;		
		$mainframe->enqueueMessage( '$reg_path ='. $reg_path ); 
		$mainframe->enqueueMessage( 'JFactory::getURI =' . $url ) ;		
		$mainframe->enqueueMessage( 'getHost =' . $u_host ) ;			
		$mainframe->enqueueMessage( 'getPath =' . $u_path ) ;			
		$mainframe->enqueueMessage( '$_SERVER[SERVER_NAME] =' . $_SERVER['SERVER_NAME'] ) ;			
		$mainframe->enqueueMessage( '$_SERVER[HTTP_HOST] =' . $_SERVER['HTTP_HOST'] ) ;	
		$mainframe->enqueueMessage( '$_SERVER[REQUEST_URI] =' . $_SERVER['REQUEST_URI'] ) ;  
		$mainframe->enqueueMessage( '$_SERVER[SCRIPT_NAME] =' . $_SERVER['SCRIPT_NAME'] ) ;
		}	
		
//	Check passphrase 
		if( $pass != $reg_pass )
		{
			if ($pass=='' && $use_module =='1') {$mainframe->enqueueMessage($intercept_message); }
			elseif ($use_module =='1') {$mainframe->enqueueMessage($fail_message); }
			if ($debug=='1' && $use_module !='1' ) {Return ;}
			$mainframe->redirect( $reg_path); //redirect since passphrase is incorrect
			Return;
		}	

//	Passphrase is correct at this point
		if ( !empty($alt_reg_url) ) //Check to see if we are using an alternate reg page
		{  
		$pos = strpos($url, $alt_reg_url);  //Check to see if already at the alternate reg page, to keep from looping redirection
		if ($pos === false) {$mainframe->redirect($alt_reg_url . '&pass=' . $reg_pass);} // redirect to alternate registration page
		}

	Return ;// return from function
	}

}
?>